import re, sys, os

NumStrings = set(["0","1","2","3","4","5","6","7","8","9"])
Labels = set(["V","T","C","C*","v","v*","Adj","P","P*","D","D*","Perf","N",'Prt'])


def LaTeXFormat(line):
   
    temp1 = re.sub("_","\_",line)
    temp2 = re.sub("{","\{",temp1)
    temp3 = re.sub("}","\}",temp2)
    temp4 = re.sub("'","",temp3)
    temp5 = re.sub("\~","$\sim$",temp4)
    line = temp5

    
    return line

def LaTeXFormat(line):
   
    temp1 = re.sub("_","\_",line)
##    temp2 = re.sub("{","\{",temp1)
##    temp3 = re.sub("}","\}",temp2)
    temp4 = re.sub("'","",temp1)
    temp5 = re.sub("\~","$\sim$",temp4)
    line = temp5

    return line


def SuperClean(line):
    ctr = 0
    Features = []
    Start = False
    new_line = str()
    while ctr < len(line):
        current = line[ctr]
        if Start == False:
            if current == "[":
                new_line += current
                ctr += 1
                Start = True
                chunk,NewCtr = GetChunk(line,ctr)
                NewChunk = "$_{" + chunk + "}$ "
                new_line += NewChunk
                ctr = NewCtr
            else:
                
                print "error234"
                return line
##                sys.exit()
            
        else:
            
            if current != " ":
                
                chunk, NewCtr = GetChunk(line,ctr)
 
                pattern = r'u[A-Z]'
                m = re.findall(pattern,chunk)
##                if m.group() == None:
##                    print "False"
##                print m.group()
##
                if m != []:
                    temp1 = re.sub("\[","",chunk)
                    temp2 = re.sub("\]","",temp1)
                    NewChunk = re.sub(",","",temp2)

                    Features.append(NewChunk)
                    ctr = NewCtr
                elif chunk[:2] == "[u":
                    temp1 = re.sub("\[","",chunk)
                    NewChunk = re.sub("\]","",temp1)
                    Features.append(NewChunk)
                    ctr = NewCtr
               
                else:
                    temp1 = re.sub("\[","",chunk)
                    NewChunk = re.sub("\]","",temp1)
##                    print "NewChunk", NewChunk
                    if NewChunk in Labels:
                        ctr = NewCtr
                    else:
                        new_line += " " + NewChunk
                        ctr = NewCtr
                        


        ctr += 1
    if new_line[-1] == " ":
        FinalLine = new_line[:-1]
    else:

        FinalLine = new_line
    if Features != []:
        FeatureString = "$_{["
        FeatCtr = 0
        while FeatCtr < len(Features):
            CurrentF = Features[FeatCtr]
            if FeatCtr == len(Features) - 1:
                FeatureString += CurrentF
            else:
                FeatureString += CurrentF + ","
            FeatCtr += 1
        FeatureString += "]}$"
        FinalLine += FeatureString
    FinalLine += "]"
    return FinalLine


def GetChunk(line,ctr):

    start = ctr
    current = line[ctr]
    Cont = True
    while Cont == True:
        ctr += 1
        if ctr == len(line):
            Cont = False
        else:
            current = line[ctr]
            if current == " ":
                Cont = False
    chunk = line[start:ctr]
 
    return chunk, ctr
    
   
def StrikeThrough(line):
##    print "line", line
    ctr = 0
    newline = str()
    while ctr < len(line):
        current = line[ctr]
        if current == "_":
            if line[ctr+1] != " ":
                newline += "\st{"
                cont = True
                ctr += 1
                while cont == True:
                    chunkCur = line[ctr]
                    if chunkCur == " ":
                        newline += "}"
                        newline += chunkCur
                        cont = False
                    else:
                        newline += chunkCur
                
                
                    ctr += 1
            else:
                newline += current
                ctr += 1
##                if ctr == len(line):
##                    cont = False
        else:
            newline += current
            ctr += 1
            
##        ctr += 1
    return newline
                
                

def CleanUpLineNoFeats(line):
    FeatsToShow = []
    ctr = 0
    new_line = str()
    while ctr < len(line):
        current = line[ctr]
        if current == "[":
            chunk = current
            i = ctr + 1
            current = line[i]
            
            while current != ",":
                chunk += current
                i += 1
                if i == len(line):
                    new_line += chunk
                    return new_line
                else: 
                    current = line[i]
                if current == "]":
                    current = ","#only a single feature
                    
##            print "chunk", chunk
            Output = CheckifFeat(chunk[2:])
##            print "Output", Output
            if Output == False:
                
                #Not a feature
##            if ":" not in chunk:
                new_line += chunk
                ctr = i
                

            else:
##                new_line += chunk
                #skip features
                
                ctr = i
                current = line[ctr]
                chunk += current
                while current != "]":
##                    new_line += current
                    ctr += 1
                    current = line[ctr]
                    chunk += current
                Features = eval(chunk)
                ShowFeats = []
                for F in FeatsToShow:
                    for Feat in Features:
                        if F in Feat:
                            ShowFeats.append(Feat)
                            
                
                if ShowFeats != []:
                    new_line += str(ShowFeats)
##                else:
##                    new_line += str([])
                

                    
                ctr += 1
                
        elif current == ",":
            ctr += 1
        else:
            
            new_line += current
            ctr += 1
    temp1 = re.sub("'s\*","AposS",new_line)
    
    temp2 = re.sub("'","",temp1)
    temp3 = re.sub('"','',temp2)
    temp4 = re.sub("AposS","'s*",temp3)
 
    FinalLine = re.sub("_SO","",temp4)
    new_line = FinalLine
##    new_line = RemoveNumbers(FinalLine)
##    print "new_line", new_line
##    print "\n\n"
    return new_line



def CleanUpLineChkdFeats(line):
    print "\nLine", line
##    print type(line)
##    print "\n"
    ctr = 0
    new_line = str()
    while ctr < len(line):
        current = line[ctr]
        if current == "[":
            chunk = current
            i = ctr + 1
            current = line[i]
            
            while current != ",":
                chunk += current
                i += 1
                if i == len(line):
                    new_line += chunk
                    return new_line
                else: 
                    current = line[i]
                if current == "]":
                    current = ","#only a single feature
                    
##            print "chunk", chunk
            Output = CheckifFeat(chunk[2:])
##            print "Output", Output
            if Output == False:
                
                #Not a feature
##            if ":" not in chunk:
                new_line += chunk
                ctr = i
                

            else:
##                print "Feature", chunk
##                new_line += chunk
                #skip features
                
                ctr = i
                current = line[ctr]
                chunk += current
                while current != "]":
##                    new_line += current
                    ctr += 1
                    current = line[ctr]
                    chunk += current
                Features = eval(chunk)
##                print "Features", Features
                ShowFeats = []
                for Feat in Features:
                    if Feat[0] == "u":
                        if "Uni" in Feat:
                            if type(eval(Feat[-1])) == int:
                                Temp = re.split('Uni',Feat)
                                NewFeat = Temp[0]
                                Feat = NewFeat
                        ShowFeats.append(Feat)
                            
                
                if ShowFeats != []:
                    new_line += str(ShowFeats)
                else:
                    True
##                    new_line += str([])
                

                    
                ctr += 1
                
        elif current == ",":
            ctr += 1
        else:
##            print "current", current
##            print "new_line", new_line
##            print "current", current
            new_line += current
            ctr += 1
##    print "newline", new_line
##    sys.exit() 


##    print "Cleaned", new_line

    temp1 = re.sub("'s\*","AposS",new_line)
    
    temp2 = re.sub("'","",temp1)
    temp3 = re.sub('"','',temp2)
    temp4 = re.sub("AposS","'s*",temp3)
 
    FinalLine = re.sub("_SO","",temp4)
    new_line = RemoveNumbers(FinalLine)

    
##    temp = re.sub(" ]","]",new_line)
##    temp1 = re.sub("'","",temp)
##    FinalLine = re.sub("_SO","",temp1)
##    print "PartFeats", FinalLine
    print "new_line", new_line
    print "\n"
    return new_line


def RemoveNumbers(line):
    ctr = 0
    new_line = str()
    while ctr < len(line):
        current = line[ctr]
        if current in NumStrings:
            ctr  += 1
            new_line += " "
        else:
            new_line += current
        ctr += 1
    return new_line           

def CheckifFeat(Chunk):
    if len(Chunk) == 0:
        return Chunk
    Feat = False
    if Chunk[0] == "u":
        Feat = True
    
    elif Chunk[0] == "i":
        if Chunk[1] == "n":
            #"in" is not a feature- in is a P
            True
        else:
            Feat = True
    elif Chunk[:2] == "EF":
        Feat = True
    elif "MergeF" in Chunk:
        Feat = True
    elif "Chkd" in Chunk:
        Feat = True
    elif "Case" in Chunk:
        Feat = True
    elif "Root" in Chunk:
        Feat = True
    elif "Head" in Chunk:
        Feat = True
    
    
    return Feat           

class ProduceFile:
    def __init__(self,Output_L):

        self.PrintFile(Output_L)

    def PrintFile(self,Output_L):
        
        File = "../Output/OutputFull.txt"
        F = open(File,'w')

        File2 = "../Output/Output.txt"
        F2 = open(File2, 'w')

        File3 = "../Output/TreeViewer.txt"
        F3 = open(File3, 'w')

        

 

        File7 = "../Output/TexOutput.tex"
        F7 = open(File7, 'w')



        Input = "../InputFiles/LaTeXInput/TexInput.tex"

        TexIn = open(Input,'r')
        Cont = True
        lines = TexIn.readlines()
        ctr = 0
##        print "Counter", ctr
        while ctr < len(lines):
            current = lines[ctr]
        
            if "begin{document" in current:

              
                
 
                F7.write(current)
#

                
                ctr = len(lines)

            else:
 
                F7.write(current)
##                print "Write current", current
##                print "\n\n"
                ctr += 1
                
        Start = True
        ctr = 0
        Descript = str()
        while ctr < len(Output_L):
            
            current = Output_L[ctr]
##            print "Current", current
            if len(current) == 3:
                if Start == True:
                    Start = False
                else:
                    F7.write("\\end{itemize}\n\n")
               
                Num = current[0]
                Sent = current[1]
                Numeration = current[2]
                F.write("\n%s %s\n%s\n\n\n" %(Num, Sent,Numeration))
                F2.write("\n%s %s\n%s\n\n\n" %(Num, Sent,Numeration))
                if "_" in Sent:
                    SentTex = str()
                    SentCtr = 0
                    while SentCtr < len(Sent):
                        Current = Sent[SentCtr]
                        if Current == "_":
                            SentTex += "$_"
                            SentCtr +=1
                            Current = Sent[SentCtr]
                            while Current not in Punct:
                                SentTex += Current
                                SentCtr += 1
                                Current = Sent[SentCtr]
                            SentTex += "$ "
                        else:
                            SentTex += Current
                            SentCtr += 1
                else:
                    SentTex = Sent

                NumTex = LaTeXFormat(str(Numeration))                            
                    
                F7.write("\\begin{example}\n %s\n%s\n\\end{example}\n\n\\begin{itemize}\n" %(SentTex,NumTex))

                #Add underscores for Treedraw
                F3.write("\n%s %s\n" %(Num, Sent))
 
##                F3.write("\n\\noindent(%s) %s\\newline%s\n\\newline\\newline" %(Num, Sent, NumTex))
             
            else:
                
                Description = current[0]
##                print "Description", Description
                DataOrig = current[1]
##                print "DataOrig", DataOrig
                Data2 = CleanUpLineNoFeats(str(DataOrig))
 
                F.write("%s\n%s\n\n" %(Description,DataOrig))

                if "Description:" in Description:
                    
                    if "Label" in Description:
                        
                        if "Head" in Description:
                            
                            Descript = "Label from Head: " + Data2
                        elif "Move" in Description:
                            
                            Descript = "Label via movement: " + Data2

                        elif "SharedFeats" in Description:

                            
                            Descript = "Label via shared features: " + Data2
                        elif "Strengthened" in Description:

                            
                            Descript = "Label (Checked Phi): " + Data2

                            
                        elif "None" in Description:
                            
                            Descript = "Unlabeled: " + Data2
                        F3.write("%s\n" %(Data2))
 
                        F.write("%s\n\n" %(Descript))
                        F2.write("%s\n\n" %(Descript))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        DescriptTex = LaTeXFormat(Descript)
                        F7.write("\\item %s\n\n" %(DescriptTex))
                        Descript = False

                    elif "Merge" in Description:
                        Descript = DataOrig
                        F2.write("%s\n\n" %(Descript))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        DescriptTex = LaTeXFormat(Descript)
##                        print "Merge1111", DescriptTex
                        F7.write("\\item %s\n\n" %(DescriptTex))
                                           
                    elif "Dephase" in Description:
                        if " v" in Description:
                            Descript = "Root movement (dephase): " + Data2
                        elif "DeleteC" in Description:
                            Descript = "Delete C (dephase): " + Data2
                        
                        F2.write("%s\n\n" %(Descript))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        DescriptTex = LaTeXFormat(Descript)
##                        print "Merge1111", DescriptTex
                        F7.write("\\item %s\n\n" %(DescriptTex))
                        F3.write("%s\n" %(Data2))

                        
                     

                    elif "MRGOperations" in Description:
                        Descript = "Number of Merge Operations: " +  Data2
                        F7.write("%s\n\n" %(Descript))
                    elif "FTInheritanceOp" in Description:
                        Descript = "Number of Feature Inheritance Operations: " +  Data2
                        F7.write("%s\n\n" %(Descript))
                    elif "FTCheckOp" in Description:
                        Descript = "Number of Feature Checking Operations: " +  Data2
                        F7.write("%s\n\n" %(Descript))
                        
                        
                    elif "Transfer" in Description:
                        Descript = "Transfer: " + Data2
                        F2.write("%s\n\n" %(Descript))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        DescriptTex = LaTeXFormat(Descript)
##                        print "Merge1111", DescriptTex
                        F7.write("\\item %s\n\n" %(DescriptTex))


                        
                    elif "UnlabeledM" in Description:
                        Descript = "Unlabeled Merge: " + Data2
                        F2.write("%s\n\n" %(Descript))
                        F3.write("%s\n" %(Data2))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        NewDescript = StrikeThrough(Descript)

                        DescriptTex1 = LaTeXFormat(NewDescript)

                        F7.write("\\item %s\n\n" %(DescriptTex1))
##                        print "!!!!!!Unlabeled", DescriptTex1
##                        print "\n\n\n"
                    elif "PassFs" in Description:
                        Descript = DataOrig
                        F2.write("%s\n\n" %(Descript))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        DescriptTex = LaTeXFormat(Descript)
##                        print "Merge1111", DescriptTex
                        F7.write("\\item %s\n\n" %(DescriptTex))

                        
                    elif "FeaturesPassed" in Description:
                        Descript = "Passed Features: " + Data2
                        F2.write("%s\n\n" %(Descript))

                        DescriptTex = LaTeXFormat(Descript)
                        newDescript = RemoveNumbers(DescriptTex)


                        F7.write("\\item %s\n\n" %(newDescript))

                        
                        
                    elif "CheckedFeatures" in Description:
                        Descript = "Checked Features: " + Data2
                        F2.write("%s\n\n" %(Descript))

                        DescriptTex = LaTeXFormat(Descript)
                        newDescript = RemoveNumbers(DescriptTex)


                        F7.write("\\item %s\n\n" %(newDescript))

                        
##                        F7.write("\\item %s\n\n" %(DescriptTex))

                    elif "LbAfterMove" in Description:
                        Descript = Data2 + " labels"
                        F2.write("%s\n\n" %(Descript))
                        F3.write("%s\n" %(Descript))
                        DescriptTex = LaTeXFormat(Descript)
##                        print "DescriptTex", DescriptTex
##                        print "\n\n\n\n"
                        F7.write("\\item %s\n\n" %(DescriptTex))
                        
                    elif "LbM" in Description:
                        Descript = "Labeled After Move: " + Data2
                        F2.write("%s\n\n" %(Descript))
                        F3.write("%s\n" %(Data2))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        DescriptTex = LaTeXFormat(Descript)

                        F7.write("\\item %s\n\n" %(DescriptTex))
                        
                    elif "PhiPassing" in Description:
                        Descript = "Phi Passed from N to D"
                        F2.write("%s\n\n" %(Descript))
                        DescriptTex = LaTeXFormat(Descript)

                        F7.write("\\item %s\n\n" %(DescriptTex))

                        
                    if "Push" in Description:
                        Descript = "Push: " + Data2
                        F2.write("%s\n\n" %(Descript))
                        temp = re.sub("\~","$\sim$",Descript)
                        Descript = temp
                        DescriptTex1 = LaTeXFormat(Descript)

                        F7.write("\\item %s\n\n" %(DescriptTex1))


                        
                    elif "ClearStack" in Description:
                        Stack = eval(DataOrig)
                        Stack.reverse()
##                        print "Stack", Stack
                        
                        Descript = "Clear Stack: "
                        F2.write("%s\n\n" %(Descript))
                        F7.write("\\item %s\n\n" %(Descript))
##                        print "Descript", Descript
##                        print "Stack", Stack
                        StackCtr = 1
                        for Elem in Stack:
                            print "Elem", Elem
                            NewElem = CleanUpLineNoFeats(str(Elem))
                            PrintElem = str(StackCtr) + " POP: " + NewElem
                            F2.write("%s\n\n" %(PrintElem))
                            TexElem = LaTeXFormat(PrintElem)

                            F7.write("\\item %s\n\n" %(TexElem))
                            StackCtr += 1
                    elif "Unification" in Description:
                        Descript = "Unify Features: " + DataOrig
                        F.write("%s\n\n" %(Descript))
                        F2.write("%s\n\n" %(Descript))
                        DescriptTex = LaTeXFormat(Descript)
                        F7.write("\\item %s\n\n" %(DescriptTex))

                        
                    elif "SubStream" in Description:
##                        print "Sub"
 
                        F2.write("Substream\n\n" )
                        F7.write("\\item Substream\n\n" )

                    elif "MainStream" in Description:
 
                        F2.write("Main Stream\n\n" )
                        F7.write("\\item Main Stream\n\n" )    
                    
                    elif "Stack" in Description:
##                        print "ClearStack"
                        Stack = eval(DataOrig)
                        Stack.reverse()
##                        print "Stack", Stack

                        if "Transfer" in Description:
                            Descript = "Stack after Transfer: "
                        else:
                            Descript = "Stack: "
                        F2.write("%s\n\n" %(Descript))
                        F7.write("\\item %s\n\n" %(Descript))
                        StackCtr = 1
                        for Elem in Stack:
##                            print "Elem", Elem
                            NewElem = CleanUpLineNoFeats(str(Elem))
                            PrintElem = str(StackCtr) + ": " + NewElem
                            F2.write("%s\n\n" %(PrintElem))
                            TexElem = LaTeXFormat(PrintElem)

                            F7.write("\\item %s\n\n" %(TexElem))
                            StackCtr += 1
                    elif "Crash" in Description:
                        if "Unchecked Feature" in Description:
                            Descript = "Crash (Unchecked Feature): " + Data2
                            temp = re.sub("\~","$\sim$",Descript)
                            Descript = temp
                            DescriptTex = LaTeXFormat(Descript)
                            F7.write("\\item %s\n\n" %(DescriptTex))
                        elif "Unlabeled" in Description:
                            Descript = "Crash (Unlabeled): " + Data2
                            temp = re.sub("\~","$\sim$",Descript)
                            Descript = temp
                            DescriptTex = LaTeXFormat(Descript)
                            F7.write("\\item %s\n\n" %(DescriptTex))
                        

##                    elif "Stack" in Description:
######                        print "STACKSTACK"
####                        print Description
####                        print "data", DataOrig
####
####                        print "\n"
##                        Temp = str()
##                        TempTex = str()
##                        Data = eval(DataOrig)
####                        print "Data", Data
##                        Data.reverse()
##                        if Data == []:
##                            Temp = "[]"
##                            TempTex = "[]"
##                        else:
##                            stackctr = 1
##                            for elem in Data:
####                                print "elem", elem
##                                elem1= CleanUpLineChkdFeats(str(elem))
####                                print "elem1", elem1
##                                elem2 = StrikeThrough(elem1)
##                                
##                                elem3 = SuperClean(elem2)
####                                print "elem2", elem2
## 
##
##                                elem4 = re.sub("\~","$\sim$",elem3)
##
##                                newS = str(stackctr) + " " + elem2 + "\n"
##                                newSTex = str(stackctr) + " " + elem4 + "\\\\\n"
##                                Temp += newS
##                                TempTex += newSTex
##                                stackctr += 1
##                            TempTex1 = TempTex[:-3]
##                            TempTex = TempTex1
####                        print "Temp", Temp
##                        
##                        Descript = "Stack: \n" + Temp
####                        TexItem = re.sub("\~","$\sim$",TempTex[1:])
####                        TexItem2 = StrikeThrough(TexItem)
##                        
##                        DescriptTex = "Stack: \\\\\n{" + TempTex[0]  + "}" + TempTex[1:]
## 
##                        F2.write("%s\n\n" %(Descript))
##
##                        F7.write("\\item %s\n\n" %(DescriptTex))


                        
                        
            ctr += 1
            
            

        
##                #print example
 
        F7.write("\\end{itemize}\n\n")
        F7.write("\n\n\\end{document}")
                                        
        F.close()
        F2.close()
        F3.close()
 
        F7.close()
     


def Start(Output_L):
    a = ProduceFile(Output_L) 
