#######################################################
###Derivation Generator - Problems of Projection Version
#########################################################

import re, sys, ProduceOutput

NumStrings = set(["0","1","2","3","4","5","6","7","8","9"])

AllHeads = set(['v*','C','v','n','the','a',"D","in"])
Heads = set(['v*','v','C','n','v~',"D","D_Top","in"])
DetHeads  = set(['the','a',"D"])
PhaseHeads = set(["v*","C","C_Q","that","C_Null","C_Top","in"])
ThetaAssigners = set(["v*","vUnerg",'v','v_be'])
SharedFeatLabels = set(["Phi","Q","Top","Per"])               
TenseElems = set(['PRES','PAST'])
PhiFeats = set(["iPerson","iNumber","iGender"])
OtherFts = set(['ThetaAgr','EF','MergeF','ExplMerge','NoProject'])
SharedLabels = set(["Phi","Q","Top"])
##AdjunctLabels = set(["in","P_in"])
AdjunctLabels = set(["P_in"]) 
NumPattern = r'[0-9]+'

class Generate:
    def __init__(self, InputData):

        Start = 1#1
        Finish = 10#11
        self.Output_L = [] #List of all (important) steps in the derivation

        ctr = 0
        SentNum = 0
        while SentNum < Finish:
            CurrentL = InputData[ctr]
            
            if "English" in CurrentL:
                if CurrentL[0] not in NumStrings:
                    self.Language = "English"
                    print self.Language
                    
            if "Japanese" in CurrentL:
                if CurrentL[0] not in NumStrings:
                    self.Language = "Japanese"
                    print self.Language
##                print "line", line
##                print "SentNum", SentNum
            if CurrentL[0] in NumStrings:
                wds = CurrentL.split()
                if len(wds) == 0:
                    True
                else:
                    SentNum = eval(wds[0])
                    
                    if SentNum < Start:
                        True
                    elif SentNum == Finish:
                        True
                    else: 
##                        print "SentNum", SentNum
 
    ##                        print wds[1:]
                        Cont = True
                        SentL = []
                        WrdCtr = 1
                        while Cont == True:
                            
                            LI = wds[WrdCtr]
                        
                            if "[" in LI:
                                Cont = False
                            else:
                                 SentL.append(LI)
                            WrdCtr += 1
##                        N = TargetExample[ctr-1]
                        TargetExampleStr = wds[-1]
                    
                   
                    
                        Sent = " ".join(SentL)
##                        print "Sent", Sent
                        self.Output_L.append((SentNum,Sent,TargetExampleStr))
                        TargetExample = eval(TargetExampleStr)
                        self.GenerateDerivation(TargetExample)
##                        print "Final", self.Selected
                        
                        if self.Crash == False:
                            self.Output_L.append(("Description:Transfer",str(self.Selected)))

##                            Output = self.UnlabeledMove(self.Selected)
##                            print "UnlabeledMove222", Output
##                            if Output != False:
##                                
##                                self.Selected = Output
##                                print "Final2", self.Selected
##                            print "Final", self.Selected
##                            self.Output_L.append(("Description:Label(Head)",str(self.Selected)))
##                            self.Output_L.append(("Description:Transfer",str(self.Selected)))
                        else:
                            Output = self.LabelCheck(self.Selected)
                        self.Output_L.append(("Description:MRGOperations",str(self.MergeCtr)))
                        self.Output_L.append(("Description:FTInheritanceOp",str(self.InheritanceCtr)))
                        self.Output_L.append(("Description:FTCheckOp",str(self.FTCheckCtr)))
                        
                           
                
##                print "Output", Output
##                print "Merged", Merged
            
##                if Output != False:
####                print "MergedBefore", Merged
##                    NewMerged = Output
                        
  



##            print "SentNum", SentNum
##            print "Finish", Finish
            ctr += 1
##        print "ProduceOutput"
        ProduceOutput.Start(self.Output_L)                   
                        
    def GenerateDerivation(self,TargetExample):
##        print "TargetExample", TargetExample
        TargetExample.reverse()
        self.Selected = False
        self.SubStream = False
        self.SelectedSubS = False
        self.PhiCtr = 0
        self.FeatCtr = 0
        self.Phase = False
        self.Stack = []
        self.SubStreamStack = []
        self.Remerge = False
        self.Crash = False
        self.MergeCtr = 0
        self.InheritanceCtr = 0
        self.TransferCtr = 0
        self.FTCheckCtr = 0
        self.NextSO = False
        
        SOCtr = 0
        while SOCtr < len(TargetExample):
            SO = TargetExample[SOCtr]
            if SOCtr < len(TargetExample) - 2:
                self.NextSO = TargetExample[SOCtr+1]
            else:
                self.NextSO = False
                
##        for SO in TargetExample:
##            print "SO", SO
            
            if type(SO) == list:
                SO.reverse()
                self.GenerateMergedStruct(SO)
##                print "SO", SO
            else:
                self.GenerateMergedStruct(SO)
            SOCtr += 1
             
        if self.Selected[0] == "_":
            
            self.Output_L.append(("Description:Crash(Unlabeled)",str(self.Selected)))
##            print "crash2"
##            print "Selected", self.Selected
            self.Crash = True
           

                
               
                

        
           
            
    def GenerateMergedStruct(self,Obj):
        if type (Obj) != list:
            if self.Selected == False:
                self.Selected = self.GetForm(Obj)
            else:
                if self.SubStream != True:
                    X = self.GetForm(Obj)
                    Y = self.Selected
                    MergeData = "Merge " + X[0] + " + " + Y[0]                        
                    self.Output_L.append(("Description:Merge",MergeData))
                    self.Selected = self.Merge(X,Y)
                else:
                    if self.SelectedSubS == False:
                        self.SelectedSubS = self.GetForm(Obj)
                    else:
                        X = self.GetForm(Obj)
                        Y = self.SelectedSubS
                        MergeData = "Merge " + X[0] + " + " + Y[0]                        
                        self.Output_L.append(("Description:Merge",MergeData))
                        self.SelectedSubS = self.Merge(X,Y)
            
        else:
##            Obj.reverse()
##            print "Obj", Obj
            self.SubStream = True
            self.Output_L.append(("Description:SubStream",True))

            for SO in Obj:
                self.GenerateMergedStruct(SO)
##            print "SelectedSub", self.SelectedSubS
##            print "Selected", self.Selected
##            sys.exit()
            self.SubStream = False
            self.Output_L.append(("Description:MainStream",True))

            self.SubStreamStack = []
            MergeData = "Merge " + self.Selected[0] + " + " + self.SelectedSubS[0]                        
            self.Output_L.append(("Description:Merge",MergeData))
                    
            Temp = self.Merge(self.Selected,self.SelectedSubS)
            self.SelectedSubS = False
            self.Selected = Temp

##                    SO.reverse()
##                    self.GenerateMergedStruct(SO)
##                    print "Sub", self.SelectedSubS
##                    sys.exit()
##    ##                print "Stop"
##    ##                sys.exit()
##                else:
##    ##                print "SO", SO
##                    
##                    SOForm = self.GetForm(SO)
##                    
##                       
##                    if self.SubStream == True:
##                        if self.SelectedSubS == False:
##                            self.SelectedSubS = SOForm
##                        else:
##                            X = SOForm
##                            Y = self.SelectedSubS
##                           
##                            self.SelectedSubS = self.Merge(X,Y)
##                        
##
##                    else:                   
##                        if self.Selected == False:
##                            self.Selected = SOForm
##                        else:
##                            X = SOForm
##                            Y = self.Selected
##                            self.Selected = self.Merge(X,Y)
##                               SO.reverse()
##
##
##        
##                    
####            sys.exit()
##            if self.SubStream == True:
##                self.SubStream = False
##            
##                Temp = self.Merge(self.Selected,self.SelectedSubS)
##            
##                self.Selected = Temp
####            print "Final", self.Selected
##                self.SubStream = False
##                self.SelectedSubS = False

               
            
##            sys.exit()
        #PhaseCheck
        #do phase computations at the end of a SubNumeration?
##        self.PhaseComputations()

    def DetermineLabel(self,X,Y):
        #Head merges with root or XP, the head labels
##        print "DetermineLabel"
##        print "X", X
##        print "Y", Y
##        print "Type", type(Y)
##
 
        XFeats = self.GetHeadFeatures(X)
 
        YFeats = self.GetHeadFeatures(Y)
        
##        XFeats = self.GetHeadFeatures(X)
##        YFeats = self.GetHeadFeatures(Y)

        
        if "Head" in XFeats:
##            if "uQ" in XFeats: #Special rule that keeps C_! from labeling until after uQ is checked
##                True
##                print "No Label"
##                print "CheckFeats", X
##                print "CheckFeats", Y
##                sys.exit()
            if "Head" not in YFeats:
     
                NewXFeats = []
                for F in XFeats:
                    if F == "Head":
                        True
                    else:
                        NewXFeats.append(F)
                            
                NewX = self.ReplaceFeats(X,XFeats,NewXFeats)
                Label = NewX
                Other = Y
##                print "NewY", Other
##                print "type", type(Other)
                    
                return (Label,Other,"Head")
            
        if Y[0] in AdjunctLabels:
##            print "X", X
##            print "Y", Y
            #Assume that label is X
            Label = X
            Other = Y
            return (Label,Other,False)
        
                
                
                
        #Check for shared phi-features
        if YFeats != False:
            SharedFeats = []
            for Feat in XFeats:
                if Feat in YFeats:
                    SharedFeats.append(Feat)
            if SharedFeats == []:
    ##            print "None11111"
            
                        
                return (False,False,False)
##        print "False False False"
        return (False,False,False)
                    
    def Merge(self,X,Y):
##        print "\n\n\nMergeX", X
##        print "MergeY", Y
##        print "TypeY", type(Y)
       
##        print "STack"
##        for elem in self.Stack:
##            print "elem", elemdedef Mergef Merge
##        print "\n\n"
        pattern = r'u[A-Z]'
        FirstMergeX = False
        FirstMergeY = False
        XFeats = self.GetHeadFeatures(X)
        if "MergeF" in XFeats:
            FirstMergeX = True
       
            
        YFeats = self.GetHeadFeatures(Y)
        if YFeats == False:
            FirstMergeY = True
        elif "MergeF" in YFeats:
            FirstMergeY = True
        
 
        #push to stack if unlabeled or if it has uFs
        if self.SubStream == False:
            #push to stakdef Merge
            if X not in self.Stack:
                self.Stack.append(X)
            if Y not in self.Stack:
                self.Stack.append(Y)

        else:

##            if X not in self.SubStreamStack:
            if X not in self.SubStreamStack:
                self.SubStreamStack.append(X)
####                self.Output_L.append(("Description:Push",str(X)))
            
            if Y not in self.SubStreamStack:
                self.SubStreamStack.append(Y)
##                self.Output_L.append(("Description:Push",str(Y)))
                
##        MergeData = "Merge " + X[0] + " + " + Y[0]                        
##        self.Output_L.append(("Description:Merge",MergeData))
##        print "Self.RemergeBefore11", self.Remerge
        (NewX,NewY,FeatsPassed) = self.CheckFeats(X,Y)
##        print "NewX", NewX
##        print "NewY", NewY
##        print "Self.RemergeAfter11", self.Remerge

            
        X = NewX
        Y = NewY
        
        (XOut,YOut,LabelInfo) = self.DetermineLabel(X,Y)
 
##        print "Type", type(XOut)
##        print "Type", type(YOut)
##        print "YOut", YOut
        if XOut != False:
        
            Label = XOut
            Other = YOut            
            Merged = []
            Merged.append(Label[0])
            self.MergeCtr += 1
            if self.Language == "Japanese":
                Merged.append(Other)
                Merged.append(Label)
##                print "MergedOutput", Merged
##                print "\n\n"
            else:
                Merged.append(Label)
                Merged.append(Other)
##                print "Output", Merged
##                print "\n\n"
            
##            if Merged[0] in PhaseHeads:
####                print "MergedBeforeTransferCheck", Merged
##                TransferOutput = self.TransferCheck(Merged)
##                if TransferOutput != Merged:
##                    Merged = TransferOutput
##                    print "MergedAfterTransferCheck", Merged
##                    sys.exit()
##                    print "\n\n"
            
##                    print "Merged113", Merged
            if FeatsPassed == True:
                if LabelInfo == "Head":
##                print "Description2", Merged
                    self.Output_L.append(("Description:Label(Head)",str(Merged)))
##                    print "\n\n"
##            print "NEwMerged", Merged
##            print "UnlabeledMoveInput1"
##            print "Self.RemergeBefore", self.Remerge
            if self.Language == "English":
                Output = self.UnlabeledMove(Merged)
                if Output != False:
                    Merged = Output
    ##                print "Self.RemergeBefore77", self.Remerge
                    XFeats = self.GetHeadFeatures(X)
            if self.Remerge != False:
##                print "Remerge5555", self.Remerge
                #CheckFeats of RemergedElement??
                
                #Find Shared Feats
                SharedFeats = []
                MergedFeats = self.GetHeadFeatures(Merged)
                RemergeFeats = self.GetHeadFeatures(self.Remerge)
                for F in MergedFeats:
                    if F in RemergeFeats:
                        SharedFeats.append(F)
##                print "SharedFeats", SharedFeats
                if "iQ" in str(SharedFeats):
                    Label = "Q"
                elif "iTop" in str(SharedFeats):
                    Label = "Top"
                else:
                    print "SharedFeats", SharedFeats
                    print "Merged", Merged
                    print "Remerge", self.Remerge
                    print "Can't Determine Label 5555"
                    sys.exit()

                
 


                RemergeFeats = self.GetHeadFeatures(self.Remerge)
##            print "RemergeFeats", RemergeFeats
                NewRemergeFeats = RemergeFeats + ["Copy"]
##            print "NewRemergeFeats", NewRemergeFeats

##                NewRemergeTemp = self.ReplaceElemInString((str(self.Remerge)),str(RemergeFeats),str(NewRemergeFeats))
##                NewRemerge = eval(NewRemergeTemp)
            

                if self.SubStream == False:
                    TempMerged = self.ReplaceEverywhere(Merged,str(RemergeFeats),str(NewRemergeFeats))
                    Merged = TempMerged

                    
##                    TempMerged = self.ReplaceEverywhere(Merged,str(self.Remerge),str(NewRemerge))
##                    Merged = TempMerged

##                    TempStack = self.ReplaceEverywhere(self.Stack,str(self.Remerge),str(NewRemerge))
##                    self.Stack = TempStack
                    TempStack = self.ReplaceEverywhere(self.Stack,str(RemergeFeats),str(NewRemergeFeats))
                    self.Stack = TempStack
                else:
                    print "Do in substream999999"
                    sys.exit()
                NewMerged = []
                NewMerged.append(Label)
                NewMerged.append(self.Remerge)
##                print "NewMErged1111\n\n", NewMerged
                self.MergeCtr += 1
               



 
                NewMerged.append(Merged)
##                print "Remerge888", self.Remerge
##                print "Merged", Merged
                MergeData = "Merge (for labeling) " + Merged[0] + " + " + self.Remerge[0]

                
##                print "Merge for labeling", Merged
##                print "Self.Remerge", self.Remerge
##                print "\n"
##                sys.exit()
                self.Output_L.append(("Description:Merge",MergeData))

                Merged = NewMerged
                self.Output_L.append(("Description:Label(SharedFeats)",str(Merged)))
##                print "Label via shared FEatures1", NewMerged
##                print "\n"
##                print "Before LabelCheck after remerge", Merged
##
##                
##                sys.exit()
##                print "Stack"
##                for elem in self.Stack:
##                    print "elem", elem
                Output = self.LabelCheck(Merged)
##                print "\n\n\nLAbeing Input", Merged
     
                
##                print "Output", Output
##                print "Merged", Merged
            
                if Output != False:
##                print "MergedBefore", Merged
                    NewMerged = Output
                    Merged = NewMerged
##                    self.Output_L.append(("Description:Label(Head)",str(Merged)))
##                    print "MergedHere11", Merged
##                    print "\n\n"

                    
                self.Remerge = False
##                print "Crash", self.Crash
##                print "FeatureCheckMerged", Merged
##                sys.exit()

##                print "UnlabeledMoveOutput", Merged
##                print "StackTop", self.Stack[-1]
##                print "\n\n"

       
            
                                        
        else:
            #Check if adjunct

            
            
            
                
            Merged = []
            Merged.append("_")
            self.MergeCtr += 1
            

            #ordering doesn't matter, but this makes things easier
            Complete = False
##            print "X", X
##            print "Y", Y
            if "v" in X[0]:
                if self.Language == "Japanese":
                    if Y[0][0] == "n":
                        Merged.append(Y)
                        Merged.append(X)
                        Complete = True
##                    else:
##                        Merged.append(X)
##                        Merged.append(Y)
##                        Complete = True

                    
                elif Y[0][0] == "D":
                    Merged.append(Y)
                    Merged.append(X)
                    Complete = True
                    
                elif Y[0][0] == "Q":
                    Merged.append(Y)
                    Merged.append(X)
                    Complete = True
            elif "C" in X[0]:
                if self.Language == "Japanese":
       
                    Merged.append(X)
                    Merged.append(Y)
                else:
                    
                    Merged.append(Y)
                    Merged.append(X)
     
                    
     
                Complete = True
            elif "P_in" in X[0]:
               
                Merged.append(Y)
                Merged.append(X)
                Complete = True
                   
            if Complete == False:
##                print "X", X
##                print "Y", Y
                if FirstMergeX == True:
                    #X must label
                    
                    if self.Language == "Japanese":
                        Merged.append(Y)
                        Merged.append(X)
                    else:
                        Merged.append(X)
                        Merged.append(Y)
                else:
                    if self.Language == "Japanese":
                        Merged.append(X)
                        Merged.append(Y)
                    else:
##                        if "Root" in str(YFeats):
##                            Merged.append(X)
##                            Merged.append(Y)
##                            print "Merged", Merged
##                            sys.exit()
##                        else:
                            
                    
                        Merged.append(Y)
                        Merged.append(X)
                        
                        
   
                        
##                #Check to see if simplex
##                if Y[0][0] == "D":#Order D to the left - subject
##                    Merged.append(Y)
##                    Merged.append(X)
##                elif Y[0][0] == "Q":#Order D to the left - subject
##                    Merged.append(Y)
##                    Merged.append(X)
##                else:
##                    
##                
##                    Merged.append(X)
##                    Merged.append(Y)

 
##            print "Description3", Merged
            self.Output_L.append(("Description:Label(None)",str(Merged)))
            #If unlabled - then remerge next available element with phi-features
##            print "UnlabeledMoveInput2"
            Output = self.UnlabeledMove(Merged)
            if Output != False:
                Merged = Output
                XFeats = self.GetHeadFeatures(X)
##                print "UnlabeledMoveOutput",Merged
##                print "StackTop", self.Stack[-1]
##                print "\n\n"
            #SEe if there are any uFs in XFeats
##        print "Merged", Merged
        
        if Merged[0] != "_":
##            print "Merged", Merged
            MergedFeats = self.GetHeadFeatures(Merged)
##            print "MErgedFeats", MergedFeats
            
            uFs = []
            pattern = r'[^1-9]+'
            for F in MergedFeats:
                if F[0] == "u":
                    if "uCase" not in F:
                        if "uScp" not in F:
                            m = re.findall(pattern,F)
                            GoalTemp = m[0]
                            Goal = "i"+ GoalTemp[1:]
                            Tup = (F,Goal)
                            uFs.append(Tup)
                    
            if uFs != []:
##                print "Merged", Merged
##                print "NewuFs", uFs
                Found = False
##                sys.exit()
            #Search STack for element with a matching Goal
                Cont = True
                if self.SubStream == False:
                    if self.Stack == []:
                        True
                    else:
                        StackCtr = len(self.Stack) - 1
                        Cont = True
                        while Cont == True:
                            Current = self.Stack[StackCtr]
                            if Current[0] == "_":
                                True
                            else:
                                CurrentFeats = self.GetHeadFeatures(Current)
                                for F in CurrentFeats:
                                    for tup in uFs:
                                        Goal = tup[1]
                                        if Goal in F:
##                                        print "Found", Current
##
##                                        print "MErged", Merged
                                            Found = True
##                                            print "Remerge Current", Current
                                            MergeData = "Merge (Feature Check) " + Merged[0] + " + " + Current[0]
                                            self.Output_L.append(("Description:Merge",MergeData))

                                            OutputMerged = self.Merge(Merged,Current)
                                            Merged = OutputMerged
##                                            print "NewMerged", Merged
                                            
##                                            Output = self.LabelCheck(Merged)
####                                            print "Output", Output
##                                            
##                                            sys.exit()
##            
##                                            if Output != False:
####                print "MergedBefore", Merged
##                                                NewMerged = Output
##                                                Merged = NewMerged
                                            
                                            Cont = False
##                                        print "NewMerged", OutputMerged
##                                        sys.exit()
                            StackCtr -= 1
                            if StackCtr < 0:
                                Cont = False
                    if Found == False:
                        self.Output_L.append(("Description:Crash(Unchecked Feature)",str(Merged)))
##                        print "crash1"
##                        print "Merged", Merged
                        self.Crash = True
                        
                        
##        if Merged[0] == "_":
##        if self.Crash == False:
##            Output = self.TransferCheck(Merged)
##            if Output != False:
##                Merged = Output

 
            
##        print "MergedOutput", Merged
##        print "Stack Here"
##        for elem in self.Stack:
##            print "Elem", elem
##        print "After STack"
##        print "\n\n"
##        print "Crash", self.Crash
        if self.Crash == False:
##            print "Merged TRansfer Check!!!", Merged
##            print "\n\n\n"
            if Merged[0] in PhaseHeads:
##                print "MergedBeforeTransferCheck", Merged
                TransferOutput = self.TransferCheck(Merged)
                if TransferOutput != Merged:
                    Merged = TransferOutput
       
##        print "MergedOutput", Merged
##        print "Stack"
##        for elem in self.Stack:
##            print "elem", elem
##        print "STackover\n\n\n"
##        if self.SubStream == False:
##            if Merged not in self.Stack:
##                self.Stack.append(Merged)
##        else:
##            self.SubStreamStack.append(Merged)
##        if "v*" in Merged[0]:
##            print "MergedOutput", Merged
##            sys.exit()
##        print "Merged", Merged
##        print "\n"
        if self.Remerge != False:#Bug in program?
            self.Remerge = False
##        print "Merged", Merged
        return Merged

        



    def TransferCheck(self,Merged):
##        print "\n\nTransferCheck"
##        print "Merged", Merged
##        print "Stack Before Transfer"
##        for elemn in self.Stack:
##            print "elem", elemn
        Transfered = False
        Remerge = False
        
##         print "\n"
##        MergedPosits = []
##        if self.SubStream == False:
##            ctr = 0
##            while ctr < len(self.Stack):
##                Current = self.Stack[ctr]
##                if Current == Merged:
##                    MergedPosits.append(ctr)
##                    print "AppendHere", ctr
##                    sys.exit()
##                ctr += 1
           
        MergedLabel = Merged[0]
        MergedFeats = self.GetHeadFeatures(Merged)
        
        if MergedLabel == "v*":
            if self.Language == "Japanese":
                True #No dephasing
            else:
        
        
            
                
                #Find closest Root
                Cont = True
                if self.SubStream == False:
                    StackCtr = len(self.Stack) - 1
                while Cont == True:
                    Current = self.Stack[StackCtr]
                    CurrentFeats = self.GetHeadFeatures(Current)
                    if "Root" in str(CurrentFeats):
                    
                        Remerge = Current
    ##                    print "Remerge", Remerge
    ##                    print "\n\n\n"
                        Cont = False
                        #TRansfer the complement of v
                        Transfer = self.FindTransferChunk(Current,Merged)
 
##                    sys.exit()
##                    
##                    Transfer = self.Stack[StackCtr+1]
 
                    
                        Temp = self.Stack[StackCtr:]
                    
                        self.Stack = Temp
                    


 
                        
                    StackCtr -= 1
                    if StackCtr < 0:
                        Cont = False
                
                if Remerge != False:
                    #Dephasing takes the head of the merged structure
                    MergedHead = Merged[1]
     
                    NewLabel = Remerge[0] + "+" + MergedLabel
                    NewMerged = []
                    NewMerged.append(NewLabel)
                    if Merged[1][0] == MergedLabel:
                        Target = Merged[1]
    ##                    print "Target", Target
                        MergedFirst = [NewLabel] + Target[1:]
    ##                    MergedFirst.append(NewLabel)
    ##                    MergedFirst.append(Target[1:])
                        NewMerged.append(MergedFirst)
                        NewMerged.append(Merged[2])
                    
                    
                    
                    else:
                                    
                                       
                
                        NewMerged += Merged[1:]
                
                    Merged = NewMerged
                    self.Output_L.append(("Description:Dephase v",str(Merged)))
                    self.Output_L.append(("Description:Transfer",str(Transfer)))
                    self.Transfered = False
##                self.Stack.append(Remerge)
                #Push Remerge onto stack too
                
                
##                if MergedPosits != []:
##                    ctr = 0
##                    if self.SubStream == False:
##                        NewStack = []
##                        while ctr < len(self.Stack):
##                            Current = self.Stack[ctr]
##                            if ctr in MergedPosits:
##                                NewStack.append(NewMerged)
##                            else:
##                                NewStack.append(Current)
##                            ctr += 1
##                        print "NewStack", NewStack
##                        sys.exit()
                        
                            

                    #Check to see if Remerge results in labeling
                    if self.SubStream == False:
                        if self.Stack == []:
                            True
                        else:
                            StackCtr = len(self.Stack) - 1
                            Cont = True
                            while Cont == True:
                                Current = self.Stack[StackCtr]
##                        print "Current", Current
                        
                                if Remerge == Current[1]:
                                    if Current[0] == "_":
                                        print "Releabel", Current
                                        sys.exit()
                                StackCtr -= 1
                                if StackCtr < 0:
                                    Cont = False
##                    print "Stack After Transfer"
##                    for elemn in self.Stack:
##                        print "elem", elemn
##                    print "\n"
                    

                                  
        if Merged[0] in PhaseHeads:#This is last resort
##            Transfer = True
##            print "Last Resort Check"
##            print "MErged", Merged
##            print "STack"
##            for elem in self.Stack:
##                print "elem", elem
##            print "\n\n"
            Dephase = False

            if "Delete" in MergedFeats:
##                print "Delete C"
##                print "Merged dephase", Merged
                
                Spec = Merged[1]
                SpecFeats = self.GetHeadFeatures(Spec)
                
##                print "Merged[1]", Merged[1]
##                print "SpecFeats", SpecFeats
##                print "MergedBefore000", Merged
                SpecPres = False
                if SpecFeats != MergedFeats:
                    
 
                    if "Delete" not in SpecFeats:
                        SpecPres = True
                        NewMerged = []
                        NewMerged.append(Merged[0])
                        NewMerged.append(Merged[1])
                        Core = Merged[2]
                        CoreDeleteHead = Core[2]
                        #Core Head needs to be deleted
                        
                        NewMerged.append(CoreDeleteHead)
##                        print "NewMerged", NewMerged
##                    sys.exit()
                if SpecPres == False:
                    NewMerged = Merged[2]
                    
##                print "NewMerged", NewMerged
##                NewMerged = Merged
                self.Output_L.append(("Description:Dephase(DeleteC)",str(NewMerged)))
                Merged = NewMerged
                MergedFeats = self.GetHeadFeatures(Merged)
                Dephase = True
                TargetLabel = Merged[0]
                #Transfer phasehood to T and transfer complement
            
                if TargetLabel == "_":
                    TargetLabel = Merged[2][0]
                if "Phi" in TargetLabel:
                    TargetLabel = Merged[2][0]
 
                 
                Cont = True
                if self.SubStream == False:
                
                    StackCtr = len(self.Stack) - 1
        ##            print "STackBefore", self.Stack
        ##            print "StackTop", self.Stack[-1]
                        
                    Cont = True
                    while Cont == True:
                        Current = self.Stack[StackCtr]
                        CurrentLabel = Current[0]
        ##                    print "Current", Current
                        if CurrentLabel == TargetLabel:
                                #Find next element that lacks this label
                            Next = self.Stack[StackCtr-1]
                            if Next[0] != CurrentLabel:
                                Transfer = Next
                                Cont = False
         
     
                        StackCtr -= 1
                        if StackCtr < 0:
                            Cont = False
                
  

                        

                
##                Transfer = False #C is deleted so there is nothing to transfer
                


                
            MergedLabel = Merged[0]
            
            Remerge = False
            #checkStack
            Cont = True
            if self.SubStream == False:
                Ctr = len(self.Stack) - 1
            else:
                Ctr = len(self.SubStreamStack) - 1
                
                
            while Cont == True:
                if self.SubStream == False:
                    Current = self.Stack[Ctr]
                    CurrentLabel = Current[0]
                    if CurrentLabel == MergedLabel:
                        True#Skip
                    elif "Phi" in CurrentLabel:
                        True
                    else:
                        CurrentFeats = self.GetHeadFeatures(Current)
                        pattern = r'u[A-Z]+'
                        m = re.findall(pattern,str(CurrentFeats))
                        if m != []:
##                            print "LR Current", Current
##                            print "Merged", Merged
##     
                            #if Current is already Merged to element that shares features with
                            #phase head, then Remerge isn't possible
                            #Find complement of Current
                            #See if complement shares features with phase head
                            TempCont = True
                            StackCtrTemp = len(self.Stack) - 1
                            while TempCont == True:
                                TempStackCurrent = self.Stack[StackCtrTemp]
                                if Current in TempStackCurrent:
                                    if Current != TempStackCurrent:
                                        if Current == TempStackCurrent[1]:
                                            Complement = TempStackCurrent[2]
                                        elif Current == TempStackCurrent[2]:
                                            Complement = TempStackCurrent[1]
##                                        print "Complement", Complement
                                        ComplementFeats = self.GetHeadFeatures(Complement)
                                        SharedFeats = []
                                        for TempF in ComplementFeats:
                                            if TempF in MergedFeats:
                                                SharedFeats.append(TempF)
##                                        print "SharedFeats", SharedFeats
                                        if SharedFeats != []:
                                            if Dephase == False:
                                                Message = "Remerge of " + Current[0] + " blocked by Remerge Condition (shared features)"
                                                self.Output_L.append(("Description:Merge",Message))
##                                            print "LR Current", Current
##                                            print "Merged", Merged
##                                            print "blocked"
##                                            sys.exit()
                                        else:
                                            Remerge = Current
                                        TempCont = False
                                    
                                StackCtrTemp -= 1
                                if StackCtrTemp < 0 :
                                    TempCont = False
    
                                    
                                        
                                
                                
##                            Remerge = Current
 
##                        for elem in self.Stack:
##                            print "elem", elem
##                        sys.exit()
                            Cont = False
                Ctr -= 1
                if Ctr < 0:
                    Cont = False
                        #uF present
                if Remerge != False:
                    NewMerged = []
                    
                    NewMerged.append("_")
##                    NewMerged.append(Merged[0])
                    NewMerged.append(Remerge)

                    RemergeFeats = self.GetHeadFeatures(Remerge)
##            print "RemergeFeats", RemergeFeats
                    NewRemergeFeats = RemergeFeats + ["Copy"]


                    

                    NewRemergeTemp = self.ReplaceElemInString((str(Remerge)),str(RemergeFeats),str(NewRemergeFeats))
                    NewRemerge = eval(NewRemergeTemp)
                    if self.SubStream == False:
                        TempMerged = self.ReplaceEverywhere(Merged,str(Remerge),str(NewRemerge))
                        Merged = TempMerged

                        TempStack = self.ReplaceEverywhere(self.Stack,str(Remerge),str(NewRemerge))
                        self.Stack = TempStack
                    else:
                        print "Do in substream999999"
                        sys.exit()

                        
 
                    NewMerged.append(Merged)
                    
                    Merged = NewMerged
                    
                    MergeData = "Merge (due to uF) " + Remerge[0] + " + " + Merged[0]
                   
                    self.Output_L.append(("Description:Merge",MergeData))
                    self.Output_L.append(("Description:Label(Head)",str(Merged)))
##                    print "MergedHere", Merged
##                    print "\n\n"
##                    print "After Remerge", Merged
##                    print "\n\n"

 
##            print "Remerge", Remerge
 
 
  
##                    NewMerged = Merged[2]
##                    
####                print "NewMerged", NewMerged
####                NewMerged = Merged
##                self.Output_L.append(("Description:Dephase(DeleteC)",str(NewMerged)))
##                return NewMerged
            if Dephase == False:
                TargetLabel = Merged[0]
##                print "MergedAgain1", Merged
                if TargetLabel == "_":
                    TargetLabel = Merged[2][0]
                if "Phi" in TargetLabel:
                    TargetLabel = Merged[2][0]
##                    print "111"
##                print "TargetLabel", TargetLabel
                 
                Cont = True
                if self.SubStream == False:
                    StackCtr = len(self.Stack) - 1
        ##            print "STackBefore", self.Stack
        ##            print "StackTop", self.Stack[-1]
                        
                    Cont = True
                    while Cont == True:
                        Current = self.Stack[StackCtr]
                        CurrentLabel = Current[0]
        ##                    print "Current", Current
                        if CurrentLabel == TargetLabel:
                                #Find next element that lacks this label
                            Next = self.Stack[StackCtr-1]
                            if Next[0] != CurrentLabel:
                                Transfer = Next
                                Cont = False
         
         
                        StackCtr -= 1
                        if StackCtr < 0:
                            Cont = False
                else:
                    StackCtr = len(self.SubStreamStack) - 1
        ##            print "STackBefore", self.Stack
        ##            print "StackTop", self.Stack[-1]
                        
                    Cont = True
                    while Cont == True:
                        Current = self.SubStreamStack[StackCtr]
                        CurrentLabel = Current[0]
        ##                    print "Current", Current
                        if CurrentLabel == TargetLabel:
                                #Find next element that lacks this label
                            Next = self.SubStreamStack[StackCtr-1]
                            if Next[0] != CurrentLabel:
                                Transfer = Next
                                Cont = False
         
         
                        StackCtr -= 1
                        if StackCtr < 0:
                            Cont = False
 
            self.Output_L.append(("Description:Transfer",str(Transfer)))
            self.Stack = []
                
            
            if Remerge != False:
                self.Stack.append(Remerge)
##                print "Stack", self.Stack

    
##            sys.exit()
##            while Cont == True:
##                
##                #IF heaad is C, transfer complement T
##                
##                Current = self.Stack[StackCtr]
##                CurrentFeats = self.GetHeadFeatures(Current)
##                if "Root" in str(CurrentFeats):
##                    if "iPerson" not in str(CurrentFeats):
##                        Cont = False
##                        Temp = self.Stack[:StackCtr]
##                        self.Stack = Temp
##                        print "Stack", self.Stack
##                        sys.exit()
##                        
##                        self.Output_L.append(("Description:Transfer",str(self.Transfered)))
##                        self.Transfered = False
##                        print "Stack After Transfer"
##                        for elemn in self.Stack:
##                            print "elem", elemn
##                        print "\n"
##                        print "\n\n\nTRansfer", self.Stack
                    #Clear out stack
##                        NewStack = self.Stack[StackCtr:]
##                        self.Stack = NewStack
##                        self.Output_L.append(("Description:Stack(Transfer)",str(self.Stack)))
##                        self.Stack = []
 
                        
##                StackCtr -= 1
##                if StackCtr < 0:
##                    Cont = False
##
##        print "Transfer Output"
##        ctr = len(self.Stack) - 1
##        while ctr >= 0:
##            Current = self.Stack[ctr]
##            print "Stack:current", Current
##            ctr -= 1
##        print "\n"
##        
##        if "v*" in Merged[0]:
##            print "Otuput", Merged
##            sys.exit()
        if self.SubStream != False:
            self.Stack.append(Merged)
        return Merged
            
    def FindTransferChunk(self,Current,Merged):
        MergedStr = str(Merged)
        CurrentStr = str(Current)
        

        Start = MergedStr.find(CurrentStr)
##        print "MergedPart", MergedStr[Start:]
        
        Portion = MergedStr[Start:]

        PortionStart = Portion.find("Root")

        Chunk =  Portion[PortionStart:]
        Cont = True
        ctr = 0
        while Cont == True:
            Current = Chunk[ctr]
            if Current == "[":
                Cont = False
            else:
                ctr += 1
        EndSO = self.GetChunk(Chunk,ctr)
    
        Transfer = eval(Chunk[ctr:EndSO])
        return Transfer
        

    def GetChunk(self, SearchSpace, i):
        
        left_ctr = 1
        right_ctr = 0
        start = i
        i += 1
        while left_ctr != right_ctr:
            current = SearchSpace[i]
            if current == "[":
                left_ctr += 1
            elif current == "]":
                right_ctr += 1
            i += 1
            if i == len(SearchSpace):
                return i
        return i
                    
                    
 

##
##                        
##    def UnlabeledMove111(self,Merged):
####        print "\nUnlabeledMove666", Merged
##
####        print "UnlabeledMove", Merged
##        
##        if self.SubStream == False:
##            if Merged not in self.Stack:
##                self.Stack.append(Merged)
##        
######                
##       
####        print "\n\n"
####        print "Stack"
####        for elem in self.Stack:
####            print "elem", elem
####        print "Stack over"
####        print "\n\n\n"
####        for elem in self.Stack:
####            print "Stackelem", elem
##        #Move an element within an unlabeled Merged Structure
##
##        #find element in stack with phi-features and raise if possible
##        
####        print "Unlabeled Move"
####        print "Merged", Merged
##        Remerge = False
##        if Merged[0] == "_":
####            print "\nUnlabeledMove666", Merged
####            sys.exit()
##           
####            print "Check to see if anything can be remerged"
####            print "Merged", Merged
##            MergedOne = Merged[1]
##            MergedOneFeats = self.GetHeadFeatures(MergedOne)
##            if "iD" in str(MergedOneFeats):
##                if "iPerson" in str(MergedOneFeats):
##                    #There's already a DP with phi-features here, so no need to Merge another DP with Phi
##                    return False
##
##
##
##            ###Try looking into complement
##
##            Comp = Merged[2]
##            CompLabel = Comp[0]
##            if CompLabel == "_":
##            
##                CompSpec = Comp[1]
## 
##                CompSpecFeats = self.GetHeadFeatures(CompSpec)
##                if "iD" in str(CompSpecFeats):
##                    if "iPerson" in str(CompSpecFeats):
##                        Remerge = CompSpec
##            
##            elif CompLabel != "_":
##                if "Phi" in CompLabel:
##                    CompSpec = Comp[1]
##                    CompSpecFeats = self.GetHeadFeatures(CompSpec)
##                    if "iD" in str(CompSpecFeats):
##                        if "iPerson" in str(CompSpecFeats):
##                            Remerge = CompSpec
##                    elif "iQ" in str(CompSpecFeats):
##                        if "iPerson" in str(CompSpecFeats):
##                            Remerge = CompSpec
## 
####                elif "Q" in CompLabel:
####                    True
##                else:
##                
##                    CompFeats = self.GetHeadFeatures(Comp)
####                    print "Comp", Comp
##                    if "iD" in str(CompFeats):
##                        if "iPerson" in str(CompFeats):
##                            Remerge = Comp
##            
####            print "Remerge111", Remerge
##                
##                                
##            
##            
##
##
##        ReplaceTups = []
##        LabeledViaMovement = []
##        if Remerge == False:
####            print "LabelMove3", Merged
##            Output = self.LabelCheck(Merged)
####            print "Output", Output
##            
##            if Output != False:
####                print "MergedBefore", Merged
##                NewMerged = Output
##                Merged = NewMerged
####                print "Merged", Merged
####                sys.exit()
##                return Merged
####                sys.exit()
##        
##        elif Remerge != False:
##             
##            RemergeFeats = self.GetHeadFeatures(Remerge)
####            print "RemergeFeats", RemergeFeats
##            NewRemergeFeats = RemergeFeats + ["Copy"]
####            print "NewRemergeFeats", NewRemergeFeats
##
##            NewRemergeTemp = self.ReplaceElemInString((str(Remerge)),str(RemergeFeats),str(NewRemergeFeats))
##            NewRemerge = eval(NewRemergeTemp)
##
##            
##            
##            
##            
##            
##
##            
##            if self.SubStream == False:
##                TempMerged = self.ReplaceEverywhere(Merged,str(Remerge),str(NewRemerge))
##                Merged = TempMerged
##
##                TempStack = self.ReplaceEverywhere(self.Stack,str(Remerge),str(NewRemerge))
##                self.Stack = TempStack
##            else:
##                print "Do in substream999999"
##                sys.exit()
##
##                
## 
##
##            MergeData = "Merge (for labeling) " + Remerge[0] + " + " + Merged[0]
##            self.Output_L.append(("Description:Merge",MergeData))
##            print "Merge for labeling22", MergeData
##            print "Remerge", Remerge
##            print "Merged", Merged
##            print "\n\n"
##
##
####            print "LabelMove4", Merged                           
##            Output = self.LabelCheck(Merged)
####            print "Output", Output
##            
##            if Output != False:
####                print "MergedBefore", Merged
##                
##                NewMerged = Output
##                Merged = NewMerged
####            else:
####                print "False"
####                sys.exit()
####                print "NewMerged", NewMerged
####                sys.exit()
####            Merged = eval(NewMergedTemp)
####            if self.SubStream == False:
####                NewStack = self.ReplaceElemInString(str(self.Stack),str(RemergeFeats),str(NewRemergeFeats))
####                self.Stack = eval(NewStack)
##
##
##            
##            
##            #Find new MergedLabel
## 
####                    
####            print "Remerge", Remerge
####            print "StackTop", self.Stack[-1]
####            print "MErged", Merged
##            
####            for elem in self.Stack:
####                print "Stack", elem
####            sys.exit()
##                    
##            MergedLabel = Merged[0]
##            NewMerged = []
##            NewMerged.append(MergedLabel)
##            NewMerged.append(Remerge)
####            NewMerged += Merged
####            print "StackAdd1111", Remerge
####            print "Append22", Remerge
##            self.Stack.append(Remerge)
## 
####            print "NewMerged^^^^", NewMerged
## 
##
## 
####            print "STack", self.Stack
####            print "\n"
##
## 
##
##            
##
##            #FindNewLabel
##            if Merged[1] == Remerge:
##                Label = Merged[2][0]
##            else:
##                Label = Merged[1][0]
####            OldMerged = [Label] + Merged[1:]
####            LabeledViaMovement = [OldMerged]
####            tup = (Merged,NewMerged)
####            ReplaceTups.append(tup)
####            self.Output_L.append(("Description:Label(Move)",str(OldMerged)))
####            NewMerged.append(OldMerged)
##            NewMerged.append(Merged)
####            print "NewMerged", NewMerged
####            print "Remerge777", Remerge
####            print "\n\n\n"
####            MergeData = "Merge (for labeling) " + Remerge[0] + " + " + Merged[0]
####            self.Output_L.append(("Description:Merge",MergeData))
####
##
##
##
##
##            
## 
##                       
####            print "Remerge output0000", NewMerged
##            if self.SubStream == False:
####                if Merged not in self.Stack:
####                    self.Stack.append(Merged)
######            
##                self.Stack.append(NewMerged)
##            
##            Output = self.LabelCheck(NewMerged)
##           
##            #Fix this
## 
##            
##            if Output != False:
####                print "MergedOutput", Output
##                NewMerged = Output
####                Merged = NewMerged
####                sys.exit()
####                Merged = NewMerged
##            
####            self.Output_L.append(("Description:Merge",MergeData))
####            print "Description4", Merged
##            if NewMerged[0] == "_":
##                
##                self.Output_L.append(("Description:Label(None)",str(NewMerged)))
##            else:
####                print "SharedFeats888", Merged
##                self.Output_L.append(("Description:Label(SharedFeats)",str(NewMerged)))
##
####            print "NewMerged11", NewMerged
##
## 
##            
##            Cont = True
##            StackCtr = len(self.Stack) - 1
##            while Cont == True:
##                if self.SubStream == False:
##                    
##                    Current = self.Stack[StackCtr]
##                else:
##                    print "CheckSubStream55555"
##                    sys.exit()
##                if str(Remerge) in str(Current):
##                    if Remerge != Current:
##                    
##                        #print label from movement
####                        print "Current", Current
##                        CurrentFeats = self.GetHeadFeatures(Current)
##                        if "Root" in str(CurrentFeats):
##                            True
##                        else:
##                        
##                            NewCurrent = []
##                            if Current[1] == Remerge:
##                                LabelElem = Current[2]
##                                NewLabel = LabelElem[0]
##                            elif Current[2] == Remerge:
##                                LabelElem = Current[1]
##                                NewLabel = LabelElem[0]
##                            else:
##                                NewLabel = Current[0]
####                            print "What is Remerge", Remerge
####                            print "NewLabel", NewLabel
####                            sys.exit()
##                        
##                            NewCurrent.append(NewLabel)
##                            NewCurrent.append(Current[1])
##                            NewCurrent.append(Current[2])
####                            print "NewCurrent", NewCurrent
##    ##                        print "NewMerged", NewMerged
##                            if "Root" not in str(CurrentFeats):
##                               
##                                LabeledViaMovement = [NewCurrent]
##                            tup = (StackCtr,NewCurrent)
##                            ReplaceTups.append(tup)
####                        self.Output_L.append(("Description:Label(Move)",str(NewCurrent)))
####                        print "NewMerged", NewMerged
####                        print "NewCurrent", NewCurrent
##                            NewMergedTemp = self.ReplaceElemInString(str(NewMerged),str(Current),str(NewCurrent))
##                       
##                            NewMerged = eval(NewMergedTemp)
##                            
##                        
##                            if self.SubStream == False:
##                           
##
####                                TempStack = self.ReplaceEverywhere(self.Stack,str(Merged),str(NewMerged))
####                                self.Stack = TempStack
##                                TempStack = self.ReplaceEverywhere(self.Stack,str(Current),str(NewCurrent))
##                                self.Stack = TempStack
##
##
##                            Cont = False
##                        
##                    
##                
##                StackCtr -= 1
##                if StackCtr < 0:
##                    Cont = False
##
##
##            
##            
##
##        
##            if self.SubStream == False:
####                if Merged not in self.Stack:
####                    self.Stack.append(Merged)
######                
##                self.Stack.append(NewMerged)
##
##            return NewMerged
##        return False

                       
    def UnlabeledMove(self,Merged):
    
##        print "UnlabeledMove", Merged
##        print "Next", self.NextSO
##        print "Type", type(self.NextSO)
        if self.NextSO != False:
            if Merged[1][0] in ThetaAssigners:#External Merge blocks internal Merge
                if type(self.NextSO) == list:
                    First = self.NextSO[0]
                    if First in DetHeads:
                        return False
                    elif First == "n_Expl":
                        return False
                
            
##            return False #No Unlabeled Move to theta-assigners
        if self.SubStream == False:
            if Merged not in self.Stack:
                self.Stack.append(Merged)
        
####                
       
##        print "\n\n"
##        print "Stack"
##        for elem in self.Stack:
##            print "elem", elem
##        print "Stack over"
##        print "\n\n\n"
##        for elem in self.Stack:
##            print "Stackelem", elem
        #Move an element within an unlabeled Merged Structure

        #find element in stack with phi-features and raise if possible
        
##        print "Unlabeled Move"
##        print "Merged", Merged
        Remerge = False
        if Merged[0] == "_":
##            print "\nUnlabeledMove666", Merged
##            sys.exit()
           
##            print "Check to see if anything can be remerged"
##            print "Merged", Merged
            MergedOne = Merged[1]
            MergedOneFeats = self.GetHeadFeatures(MergedOne)
##            print "MergedOneFeats", MergedOneFeats
            if self.Language == "English":
                if "iD" in str(MergedOneFeats):
                    if "iPerson" in str(MergedOneFeats):
                    #There's already a DP with phi-features here, so no need to Merge another DP with Phi
                        return False
                    
                elif "iQ" in  str(MergedOneFeats):
                    if "iPerson" in str(MergedOneFeats):
##                        print "already merged??/"
                    #There's already a DP with phi-features here, so no need to Merge another DP with Phi
                        return False



            ###Try looking into complement
            Comp = Merged[2]
            
            CompLabel = Comp[0]
            if CompLabel == "_":
            
                CompSpec = Comp[1]
 
                CompSpecFeats = self.GetHeadFeatures(CompSpec)
##                print "CompSpec", CompSpec
##                print "CompSpecFeats", CompSpecFeats
                if "iD" in str(CompSpecFeats):
                    if "iPerson" in str(CompSpecFeats):
                        Remerge = CompSpec
                
                
##                        print "RemergeSpec", Remerge
 
##                        print "Remerge", CompSpec
##                        
##                        sys.exit()

                elif "iQ" in str(CompSpecFeats):
                    if "iPerson" in str(CompSpecFeats):
                        Remerge = CompSpec
##                        print "Remerge", CompSpec
                elif "iN" in str(CompSpecFeats):
                    if "uPerson" in str(CompSpecFeats):
                        Remerge = CompSpec
                        
            
            elif CompLabel != "_":
                if "Phi" in CompLabel:
                    CompSpec = Comp[1]
                    CompSpecFeats = self.GetHeadFeatures(CompSpec)
                    if "iD" in str(CompSpecFeats):
                        if "iPerson" in str(CompSpecFeats):
                            Remerge = CompSpec
##                            print "Remerge1", Remerge
                    elif "iQ" in str(CompSpecFeats):
                        if "iPerson" in str(CompSpecFeats):
                            Remerge = CompSpec
                            
 
##                elif "Q" in CompLabel:
##                    True
                else:
                
                    CompFeats = self.GetHeadFeatures(Comp)
##                    print "Comp", Comp
                    if "iN" in CompFeats:
                        Remerge = Comp
##                        print "Remerge1", Remerge
                    elif "iD" in str(CompFeats):
                        if "iPerson" in str(CompFeats):
                            Remerge = Comp
##                            print "Remerge2", Remerge
                    elif "iQ" in str(CompFeats):
                        if "iPerson" in str(CompFeats):
                            Remerge = Comp
##                            print "Remerge2", Remerge
            
##            print "Remerge111", Remerge
                
                                
            
            


            #####

        ReplaceTups = []
        LabeledViaMovement = []
        if Remerge == False:
##            print "LabelMove3", Merged
            Output = self.LabelCheck(Merged)
##            print "Output", Output
            
            if Output != False:
##                print "MergedBefore", Merged
                NewMerged = Output
                Merged = NewMerged
##                print "Merged", Merged
##                sys.exit()
                return Merged
##                sys.exit()
        
        elif Remerge != False:
             
            RemergeFeats = self.GetHeadFeatures(Remerge)
##            print "RemergeFeats", RemergeFeats
            NewRemergeFeats = RemergeFeats + ["Copy"]
##            print "NewRemergeFeats", NewRemergeFeats

            NewRemergeTemp = self.ReplaceElemInString((str(Remerge)),str(RemergeFeats),str(NewRemergeFeats))
            NewRemerge = eval(NewRemergeTemp)

            
            
            
            
            

            
            if self.SubStream == False:
                TempMerged = self.ReplaceEverywhere(Merged,str(Remerge),str(NewRemerge))
                Merged = TempMerged

                TempStack = self.ReplaceEverywhere(self.Stack,str(Remerge),str(NewRemerge))
                self.Stack = TempStack
            else:
                print "Do in substream999999"
                sys.exit()

                
 

            MergeData = "Merge (for labeling) " + Remerge[0] + " + " + Merged[0]
            self.Output_L.append(("Description:Merge",MergeData))
##            print "MErge for labeling"
##            print "Remerge", Remerge
##            print "Merged", Merged
##            sys.exit()
##            print "output", Merged
##            print "Remerge", Remerge
##            print "\n\n\n"
            if Merged[1][0] == "vUnerg":
                sys.exit()


##            print "LabelMove4", Merged                           
            Output = self.LabelCheck(Merged)
##            print "Output", Output
            
            if Output != False:
##                print "MergedBefore", Merged
                
                NewMerged = Output
                Merged = NewMerged
##                print "Output", Merged
##                print "\n\n"
                
##            else:
##                print "False"
##                sys.exit()
##                print "NewMerged", NewMerged
##                sys.exit()
##            Merged = eval(NewMergedTemp)
##            if self.SubStream == False:
##                NewStack = self.ReplaceElemInString(str(self.Stack),str(RemergeFeats),str(NewRemergeFeats))
##                self.Stack = eval(NewStack)


            
            
            #Find new MergedLabel
 
##                    
##            print "Remerge", Remerge
##            print "StackTop", self.Stack[-1]
##            print "MErged", Merged
            
##            for elem in self.Stack:
##                print "Stack", elem
##            sys.exit()
                    
            MergedLabel = Merged[0]
            NewMerged = []
            NewMerged.append(MergedLabel)
            NewMerged.append(Remerge)
##            NewMerged += Merged
##            print "StackAdd1111", Remerge
##            print "Append22", Remerge
            self.Stack.append(Remerge)
 
##            print "NewMerged^^^^", NewMerged
 

 
##            print "STack", self.Stack
##            print "\n"

 

            

            #FindNewLabel
            if Merged[1] == Remerge:
                Label = Merged[2][0]
            else:
                Label = Merged[1][0]
##            OldMerged = [Label] + Merged[1:]
##            LabeledViaMovement = [OldMerged]
##            tup = (Merged,NewMerged)
##            ReplaceTups.append(tup)
##            self.Output_L.append(("Description:Label(Move)",str(OldMerged)))
##            NewMerged.append(OldMerged)
            NewMerged.append(Merged)
##            print "NewMerged", NewMerged
##            print "Remerge777", Remerge
##            print "\n\n\n"
##            MergeData = "Merge (for labeling) " + Remerge[0] + " + " + Merged[0]
##            self.Output_L.append(("Description:Merge",MergeData))
##




            
 
                       
##            print "Remerge output0000", NewMerged
            if self.SubStream == False:
##                if Merged not in self.Stack:
##                    self.Stack.append(Merged)
####            
                self.Stack.append(NewMerged)
            
            Output = self.LabelCheck(NewMerged)
           
            #Fix this
 
            
            if Output != False:
##                print "MergedOutput", Output
                NewMerged = Output
##                Merged = NewMerged
##                sys.exit()
##                Merged = NewMerged
            
##            self.Output_L.append(("Description:Merge",MergeData))
##            print "Description4", Merged
            if NewMerged[0] == "_":
                
                self.Output_L.append(("Description:Label(None)",str(NewMerged)))
            else:
##                print "SharedFeats888", Merged
                self.Output_L.append(("Description:Label(SharedFeats)",str(NewMerged)))
                print "Label via shared FEatures2", NewMerged
                print "\n"

##            print "NewMerged11", NewMerged

 
            
            Cont = True
            StackCtr = len(self.Stack) - 1
            while Cont == True:
                if self.SubStream == False:
                    
                    Current = self.Stack[StackCtr]
                else:
                    print "CheckSubStream55555"
                    sys.exit()
                if str(Remerge) in str(Current):
                    if Remerge != Current:
                    
                        #print label from movement
##                        print "Current", Current
                        CurrentFeats = self.GetHeadFeatures(Current)
                        if "Root" in str(CurrentFeats):
                            True
                        else:
                        
                            NewCurrent = []
                            if Current[1] == Remerge:
                                LabelElem = Current[2]
                                NewLabel = LabelElem[0]
                            elif Current[2] == Remerge:
                                LabelElem = Current[1]
                                NewLabel = LabelElem[0]
                            else:
                                NewLabel = Current[0]
##                            print "What is Remerge", Remerge
##                            print "NewLabel", NewLabel
##                            sys.exit()
                        
                            NewCurrent.append(NewLabel)
                            NewCurrent.append(Current[1])
                            NewCurrent.append(Current[2])
##                            print "NewCurrent", NewCurrent
    ##                        print "NewMerged", NewMerged
                            if "Root" not in str(CurrentFeats):
                               
                                LabeledViaMovement = [NewCurrent]
                            tup = (StackCtr,NewCurrent)
                            ReplaceTups.append(tup)
##                        self.Output_L.append(("Description:Label(Move)",str(NewCurrent)))
##                        print "NewMerged", NewMerged
##                        print "NewCurrent", NewCurrent
                            NewMergedTemp = self.ReplaceElemInString(str(NewMerged),str(Current),str(NewCurrent))
                       
                            NewMerged = eval(NewMergedTemp)
                            
                        
                            if self.SubStream == False:
                           

##                                TempStack = self.ReplaceEverywhere(self.Stack,str(Merged),str(NewMerged))
##                                self.Stack = TempStack
                                TempStack = self.ReplaceEverywhere(self.Stack,str(Current),str(NewCurrent))
                                self.Stack = TempStack

##                            if NewCurrent[0] == "read+v*":
##                                print "NewCurrent11", NewCurrent
##
##                                print "Stack"
##                                for elem in self.Stack:
##                                    print "1", elem
####                                    if elem == Current:
####                                        print "Fount old one!!!"
##                                    
##                                print "\n\n\n"
##                            NewStack = []
##                            for elem in self.Stack:
##                                if elem == Current:
##                                    NewStack.append(NewCurrent)
##                                else:
##                                    NewStack.append(elem)
##                            self.Stack = NewStack
                                   
##                        if Current in self.Stack:
##                            print "Current", Current
##                            print "NewCurrent", NewCurrent
##                            sys.exit()
                            Cont = False
                        
                    
                
                StackCtr -= 1
                if StackCtr < 0:
                    Cont = False


            
            

        
            if self.SubStream == False:
##                if Merged not in self.Stack:
##                    self.Stack.append(Merged)
####                
                self.Stack.append(NewMerged)
##            for elem in self.Stack:
##                print "stack", elem
##            print "original Merged", Merged
##            
           
##            print "NewMErged", NewMerged
##            sys.exit()
##            print "return", NewMerged
            return NewMerged
        return False


##
##    
##    def UnlabeledMove11(self,Merged):
##        print "\nUnlabeledMove666", Merged
##        if self.SubStream == False:
##            if Merged not in self.Stack:
##                self.Stack.append(Merged)
######                
##       
####        print "\n\n"
####        print "Stack"
####        for elem in self.Stack:
####            print "elem", elem
####        print "Stack over"
####        print "\n\n\n"
####        for elem in self.Stack:
####            print "Stackelem", elem
##        #Move an element within an unlabeled Merged Structure
##
##        #find element in stack with phi-features and raise if possible
##        
####        print "Unlabeled Move"
####        print "Merged", Merged
##       
##                
##        Remerge = False
##        if Merged[0] == "_":
####            print "\nUnlabeledMove666", Merged
####            sys.exit()
##           
####            print "Check to see if anything can be remerged"
####            print "Merged", Merged
##            MergedOne = Merged[1]
##            MergedOneFeats = self.GetHeadFeatures(MergedOne)
##            if "iD" in str(MergedOneFeats):
##                if "iPerson" in str(MergedOneFeats):
##                    #There's already a DP with phi-features here, so no need to Merge another DP with Phi
##                    return False
##
##
##
##            ###Try looking into complement
##
##            Comp = Merged[2]
##            CompLabel = Comp[0]
##            if CompLabel == "_":
##            
##                CompSpec = Comp[1]
## 
##                CompSpecFeats = self.GetHeadFeatures(CompSpec)
##                if "iD" in str(CompSpecFeats):
##                    if "iPerson" in str(CompSpecFeats):
##                        Remerge = CompSpec
##                        print "RemergeSpec", Remerge
##            
##            elif CompLabel != "_":
##                if CompLabel == "Phi":
##                    CompSpec = Comp[1]
##                    CompSpecFeats = self.GetHeadFeatures(CompSpec)
##                    if "iD" in str(CompSpecFeats):
##                        if "iPerson" in str(CompSpecFeats):
##                            Remerge = CompSpec
##                            print "Remerge1", Remerge
## 
####                elif "Q" in CompLabel:
####                    True
##                else:
##                
##                    CompFeats = self.GetHeadFeatures(Comp)
####                    print "Comp", Comp
##                    if "iD" in str(CompFeats):
##                        if "iPerson" in str(CompFeats):
##                            Remerge = Comp
##                            print "Remerge2", Remerge
##
##
##
####                            $$$$$
######        if 1 == 2:                   
####        if Merged[0] != "_":
####            #Check to see if any elements in the stack are unlabeled
####            
######            #Look for element with "_":
####            if self.SubStream == False:
####                if self.Stack == []:
####                    return False
####                else:
####                    ctr = len(self.Stack) - 1
####            else:
####                if self.SubStreamStack == []:
####                    return False
####                else:
####                    ctr = len(self.SubStreamStack) - 1
####            Checked = False               
####            Cont = True
####            while Cont == True:
####                if self.SubStream == False:
####                    Current = self.Stack[ctr]
####                else:
####                    Current = self.SubStreamStack[ctr]
######                print "Current", Current
######                print "\n"
####                if Current[0] == "_":
######                    #Check
######                    print "Current", Current
######                    print "Found it", Current
####                    CurrentOne = Current[1]
####                    CurrentTwo = Current[2]
####                    CurrentOneFeats = self.GetHeadFeatures(CurrentOne)
####                    CurrentTwoFeats = self.GetHeadFeatures(CurrentTwo)
####                    if "Root" in str(CurrentOneFeats):
####                        if "Root" not in str(CurrentTwoFeats):
####                            Remerge = CurrentOne
####                    elif "Root" in str(CurrentTwoFeats):
####                        if "Root" not in str(CurrentOneFeats):
####                            Remerge = CurrentTwo
######                    print "Remerge111", Remerge
####                    if Remerge != False:
####                        NewCurrent = []
####                        if CurrentOne == Remerge:
####                            Label = CurrentTwo[0]
####                        elif CurrentTwo == Remerge:
####                            Label = CurrentOne[0]
####                        NewCurrent.append(Label)
####                        NewCurrent += Current[1:]
######                        print "NewCurrent", NewCurrent
####                        if self.SubStream == False:
####                            
####                            NewStack = []
######                            Before = self.Stack[:ctr]
######                            After = self.Stack[ctr:]
######                            print "Before", Before
######                            print "After", After
######                            print "Current", Current
######                            sys.exit()
####                            for elem in self.Stack:
####                                if elem == Current:
####                                    print "Found it", Current
####                                    NewStack.append(NewCurrent)
####                                else:
####                                    NewStack.append(elem)
####                            self.Stack = NewStack
####                        MergedLabel = Merged[0]
####                        NewMergedLabel = Remerge[0] + "+" + MergedLabel
####                        NewMerged = self.ReplaceEverywhere(Merged,MergedLabel,NewMergedLabel)
####                        
####
####
#### 
######                        print "NEwMErged", NewMerged
######                        print "Current", Current
######                        print "NewCurrent", NewCurrent
######                        NewMergedTemp = self.ReplaceElemInString(str(NewMerged),str(Current),str(NewCurrent))
######                        NewMerged = eval(NewMergedTemp)
####                        if self.SubStream == False:
####                            TempStack = self.ReplaceEverywhere(self.Stack,MergedLabel,NewMergedLabel)
####                            self.Stack = TempStack
####
####                            TempStack = self.ReplaceEverywhere(self.Stack,str(Merged),str(NewMerged))
####                            self.Stack = TempStack
####                            
####                        else:
####                            print "Do in substream 9999"
####                            sys.exit()
####                       
####
####
####                        
######                        NewMergedTemp = self.ReplaceElemInString(str(NewMerged),str(Current),str(NewCurrent))
######
####
####                        
####                        MergeData = "Merge (for labeling) " + Remerge[0] + " + " + Merged[0]
####                        self.Output_L.append(("Description:Merge",MergeData))
######                        print "Merge for labeling", MergeData
######                        print "Merge", Merge
######                        print "\n\n"
####
####                        self.Output_L.append(("Description:Label(Move)",str(NewCurrent)))
####                        self.Output_L.append(("Description:Label(Head)",str(NewMerged)))
######                        print "NewMerged", NewMerged
####                        print "UnlabeledMove output122", NewMerged
####                        print "\n\n"
####                        Checked = True
######                        Merged = NewMerged
####                        return NewMerged
####
####
####                        
####    
######                    print "Curren[1]", Current[1]
######                    #Remerge the head if possible and label this item
######                        #Simplex item (head)
########                    for elem in self.Stack:
########                        print "elem", elem
######                    sys.exit()
####                ctr -= 1
####                if ctr < 0:
####                    Cont = False
####            if Checked == True:
####                return Merged
####            return False
####                
####        
####        if Merged[0] == "_":
####            
####            MergedFeats = self.GetHeadFeatures(Merged[1])
####        else:
####            MergedFeats = self.GetHeadFeatures(Merged)
######        if "Root" not in str(MergedFeats):
######            return False
####        Remerge = False
######        print "Stack Portion"
######        for elem in self.Stack:
######            print "Stack elem", elem
######        print "\n\n"
####        if "Root" not in str(MergedFeats):
####            #Only Remerge with a root
####            return False
####        if self.SubStream == False:
####            if self.Stack == []:
####                return False
####            ctr = len(self.Stack) - 1
####            
####        else:
####            if self.SubStreamStack == []:
####                return False
####            ctr = len(self.SubStreamStack) - 1
####            
####        Cont = True
####        while Cont == True:
####            if self.SubStream == False:
####                Current = self.Stack[ctr]
######                print "Current", Current
####            else:
####                Current = self.SubStreamStack[ctr]
####            if Current[0] == "_":
######                print "CurrentUnlabeled", Current
####                    
####                True
####            else:
####                CurrentFeats = self.GetHeadFeatures(Current)
####                if "iPerson:" in str(CurrentFeats):
####                    if "uCase" in str(CurrentFeats):
####                        Cont = False
####                        Remerge = Current
######                        print "Remerged55555", Remerge
######                        print "Merged", Merged
######                        print "\n\n\n"
####            ctr -= 1
####            if ctr < 0:
####                Cont = False
##        
##        ReplaceTups = []
##        LabeledViaMovement = []
##        if Remerge != False:
####            print "Remerge", Remerge
##            RemergeFeats = self.GetHeadFeatures(Remerge)
####            print "RemergeFeats", RemergeFeats
##            NewRemergeFeats = RemergeFeats + ["Copy"]
####            print "NewRemergeFeats", NewRemergeFeats
####                            $$$$$
##
##
##            NewRemergeTemp = self.ReplaceElemInString((str(Remerge)),str(RemergeFeats),str(NewRemergeFeats))
##            NewRemerge = eval(NewRemergeTemp)
##            
##            
##            
##            
##
##            
##            if self.SubStream == False:
##                TempMerged = self.ReplaceEverywhere(Merged,str(Remerge),str(NewRemerge))
##                Merged = TempMerged
##
##                TempStack = self.ReplaceEverywhere(self.Stack,str(Remerge),str(NewRemerge))
##                self.Stack = TempStack
##            else:
##                print "Do in substream999999"
##                sys.exit()
##
##
##
##            MergeData = "Merge (for labeling) " + Remerge[0] + " + " + Merged[0]
##            self.Output_L.append(("Description:Merge",MergeData))
##
##            
##            Output = self.LabelCheck(Merged)
##            
##            if Output != False:
####                print "MergedBefore", Merged
##                NewMerged = Output
##                Merged = NewMerged
##            if Merged[0] == "_":
##                
##                self.Output_L.append(("Description:Label(None)",str(Merged)))
##            else:
####                print "SharedFeats888", Merged
##                self.Output_L.append(("Description:Label(SharedFeats)",str(Merged)))
##
####                print "NewMerged", NewMerged
####                sys.exit()
####            Merged = eval(NewMergedTemp)
####            if self.SubStream == False:
####                NewStack = self.ReplaceElemInString(str(self.Stack),str(RemergeFeats),str(NewRemergeFeats))
####                self.Stack = eval(NewStack)
##
##
##            
##            
##            #Find new MergedLabel
## 
####                    
####            print "Remerge", Remerge
####            print "StackTop", self.Stack[-1]
####            print "MErged", Merged
##            
####            for elem in self.Stack:
####                print "Stack", elem
####            sys.exit()
##                    
##            MergedLabel = Merged[0]
##            NewMerged = []
##            NewMerged.append(MergedLabel)
##            NewMerged.append(Remerge)
####            NewMerged += Merged
####            print "StackAdd1111", Remerge
####            print "Append22", Remerge
##            self.Stack.append(Remerge)
## 
####            print "STack", self.Stack
####            print "\n"
##
## 
##
##            
##
##            #FindNewLabel
##            if Merged[1] == Remerge:
##                Label = Merged[2][0]
##            else:
##                Label = Merged[1][0]
####            OldMerged = [Label] + Merged[1:]
####            LabeledViaMovement = [OldMerged]
####            tup = (Merged,NewMerged)
####            ReplaceTups.append(tup)
####            self.Output_L.append(("Description:Label(Move)",str(OldMerged)))
####            NewMerged.append(OldMerged)
##            NewMerged.append(Merged)
##
####            print "NewMerged11", NewMerged
##
## 
##            
##            Cont = True
##            StackCtr = len(self.Stack) - 1
##            while Cont == True:
##                if self.SubStream == False:
##                    
##                    Current = self.Stack[StackCtr]
##                else:
##                    print "CheckSubStream55555"
##                    sys.exit()
##                if str(Remerge) in str(Current):
##                    if Remerge != Current:
##                    
##                        #print label from movement
####                        print "Current", Current
##                        CurrentFeats = self.GetHeadFeatures(Current)
##                        if "Root" in str(CurrentFeats):
##                            True
##                        else:
##                        
##                            NewCurrent = []
##                            if Current[1] == Remerge:
##                                LabelElem = Current[2]
##                                NewLabel = LabelElem[0]
##                            elif Current[2] == Remerge:
##                                LabelElem = Current[1]
##                                NewLabel = LabelElem[0]
##                            else:
##                                NewLabel = Current[0]
####                            print "What is Remerge", Remerge
####                            print "NewLabel", NewLabel
####                            sys.exit()
##                        
##                            NewCurrent.append(NewLabel)
##                            NewCurrent.append(Current[1])
##                            NewCurrent.append(Current[2])
####                            print "NewCurrent", NewCurrent
##    ##                        print "NewMerged", NewMerged
##                            if "Root" not in str(CurrentFeats):
##                               
##                                LabeledViaMovement = [NewCurrent]
##                            tup = (StackCtr,NewCurrent)
##                            ReplaceTups.append(tup)
####                        self.Output_L.append(("Description:Label(Move)",str(NewCurrent)))
####                        print "NewMerged", NewMerged
####                        print "NewCurrent", NewCurrent
##                            NewMergedTemp = self.ReplaceElemInString(str(NewMerged),str(Current),str(NewCurrent))
##                       
##                            NewMerged = eval(NewMergedTemp)
##                            
##                        
##                            if self.SubStream == False:
##                           
##
####                                TempStack = self.ReplaceEverywhere(self.Stack,str(Merged),str(NewMerged))
####                                self.Stack = TempStack
##                                TempStack = self.ReplaceEverywhere(self.Stack,str(Current),str(NewCurrent))
##                                self.Stack = TempStack
##
##
##
##                            Cont = False
##                        
##                    
##                
##                StackCtr -= 1
##                if StackCtr < 0:
##                    Cont = False
##
##
##            
##            
##
##            
##
####            MergeData = "Merge (for labeling) " + Remerge[0] + " + " + Merged[0]
####        
####            self.Output_L.append(("Description:Merge",MergeData))
######            print "Description4", Merged
####            self.Output_L.append(("Description:Label(None)",str(NewMerged)))
####            print "Merge for labeling444", Merged
####            print "Remerge", Remerge
####            print "\n"
####            Output = self.LabelCheck(NewMerged)
####            if Output != False:
####                NewMerged = Output
##                    
##
##                    
####            print "Unlabeled22", NewMerged
####            if LabeledViaMovement != []:
####                if len(LabeledViaMovement) > 1:
####                    print "LabledViaMovement", LabeledViaMovement
####                    sys.exit()
######                print "Description5", Merged
######                print "LabeledViaMovement", LabeledViaMovement[0]
######                print "!!!!!!!!!!!"
######                print "\n"
####                self.Output_L.append(("Description:Label(Move)",str(LabeledViaMovement[0])))
####                RemergeChunk = LabeledViaMovement[0]
####                if ReplaceTups != []:
####                
####                    Tup = ReplaceTups[0]
####                    Index = Tup[0]
####                    New = Tup[1]
####                    if self.SubStream == False:
####                        NewStack = []
####                        ctr = 0
####                        while ctr < len(self.Stack):
####                            if ctr == Index:
####                                NewStack.append(New)
####                            else:
####                                Current = self.Stack[ctr]
####                                NewStack.append(Current)
####                            ctr += 1
####                            
######                    print "stackposition", self.Stack[Index]
######                    print "New", New
######                    print "ReplaceHere"
######                    print "NewStack"
####                    self.Stack = NewStack
####                
##
##                
##
####            print "Append", NewMerged
##            if self.SubStream == False:
####                if Merged not in self.Stack:
####                    self.Stack.append(Merged)
######                
##                self.Stack.append(NewMerged)
####            for elem in self.Stack:
####                print "stack", elem
####            print "original Merged", Merged
####            
##           
####            print "NewMErged", NewMerged
####            sys.exit()
##            return NewMerged
##        return False

    
        
    def LabelCheck(self,Merged):
##        
##        print "LabelCheck777", Merged
##        if Merged[0] == "that":
##            print "Stack"
##            for elem in self.Stack:
##                print "elem", elem
##            sys.exit()
######        print "\n"
        
        Labeled = False
        if self.SubStream == False:
            if self.Stack == []:
                return False
            ctr = len(self.Stack) - 1
        else:
            if self.SubStreamStack == []:
                return False
            ctr = len(self.SubStreamStack) - 1
        
        ctr  = 0 
##        while ctr > -1:
        Cont = True
        while Cont == True:
            if self.SubStream == False:
                Current = self.Stack[ctr]

            else:
                Current = self.SubStreamStack[ctr]
            
            if Current[0] == "_":
##                print "Current", Current
                Output = self.LabelCheckFunct(Current)
                if Output != False:
                    
##                    print "Output", Output
                   
                    if str(Current) not in str(Merged):
                        print "Error not found Label Check"
                        print "Merged", Merged
                        print "Current", Current
                        print "Output", Output
                        print "Merged", 
                        sys.exit()
                    NewMerged = self.ReplaceElemInString(str(Merged),str(Current),str(Output))
                    
                    if self.SubStream == False:
##                        print "Replace in Stack"
##                        print "Current", Current
##                        print "Output", Output
                        NewStack = self.ReplaceEverywhere(self.Stack,str(Current),str(Output))
                        self.Stack = NewStack
                    
##                    print "NewMerged", NewMerged
                    Merged = eval(NewMerged)
                    Labeled = True
##                    Tup = (ctr,Output)
##                    Tup = (Current,Output)
##                    Labeled.append(Tup)
##                    for elem in self.Stack:
##                        print "elem", elem
                
##            ctr -= 1
            ctr += 1
            if self.SubStream == False:
                
                if ctr > len(self.Stack) - 1:
                    Cont = False
            else:
                if ctr > len(self.SubStreamStack)- 1:
                    Cont = False

        if Merged[0] == "_":
            Output = self.LabelCheckFunct(Merged)
##            print "Output", Output
##            if Output != False:
##                print "Output", Output
##                sys.exit()                    
        if Labeled == True:
            return Merged
        else:
##            Output = self.TransferCheck(Merged)
##            if Output != False:
## 
##                if Output == Merged:
##                    return False
##                else:
####                    print "Merged Label check output", Output
####                    print "\n\n"
####                    sys.exit()
##                    return Output
                
                
            return False
##        if Labeled != []:
####            print "NewMerged", NewMerged
####            print "Labeled", Labeled
##            for tupelem in Labeled:
##                Old = tupelem[0]
##                New = tupelem[1]
####                print "\nOld111", Old
####                print "New111", New
####                
##                if self.SubStream == False:
##                    
##                    NewStack = self.ReplaceEverywhere(self.Stack,str(Old),str(New))
##                    self.Stack = NewStack
##            print "NewStack", NewStack
##            sys.exit()
                    


                
##            NewStack = []
##            if self.SubStream == False:
##                ctr = len(self.Stack) - 1
##            else:
##                ctr = len(self.SubStreamStack) - 1
##            while ctr > -1:
##                if self.SubStream == False:
##                    Current = self.Stack[ctr]
##                else:
##                    Current = self.SubStreamStack[ctr]
##                Altered = False
##                LabeledCtr = 0
##                while LabeledCtr < len(Labeled):
##                    LabeledCurrent = Labeled[LabeledCtr]
##                    First = LabeledCurrent[0]
##                    Second = LabeledCurrent[1]
##                    if ctr == First:
##                        NewStack.append(Second)
##                        Altered = True
##                        LabeledCtr = len(Labeled)
##                    LabeledCtr += 1
##                
##                if Altered == False:
##                    NewStack.append(Current)
##                
##                ctr -= 1
                
##            print "Stack"
##            self.Stack = NewStack
##            print "LAbelCheckOutput", NewMerged
##            if type(NewMerged) != list:
##                print "Type Error", NewMerged
##                sys.exit()
        

    def LabelCheckFunct(self,Merged):
##        print "LabelCheckFunct", Merged
        
        SharedFeats = []
        Elem1 = Merged[1]
        Elem2 = Merged[2]
        if Elem1[0] == "_":
            Elem1Feats = self.GetHeadFeatures(Elem1[1])
        else:
            Elem1Feats = self.GetHeadFeatures(Elem1)
        if Elem2[0] == "_":
            Elem2Feats = self.GetHeadFeatures(Elem2[1])
        else:
            Elem2Feats = self.GetHeadFeatures(Elem2)
        if Elem1Feats == False:
            return False
        if Elem2Feats == False:
            return False

        if Elem1[0] == "_":
            if Elem2[0] == "_":
                return False
        Weak = False
        if "Root" in str(Elem1Feats):
            Weak = True
        if Weak == True:
            if "iPerson" in str(Elem1Feats):
                
                if "iNumber" in str(Elem1Feats):
                    if "iGender" in str(Elem1Feats):
##                        print "Label", Merged
                        for Elem1F in Elem1Feats:
                            if "iPerson" in Elem1F:
                                Nums = re.findall(NumPattern,Elem1F)
                               
                                
                        NewMerged = []
                        if self.Language == "Japanese":
                            NewLabel = Merged[-1][0]
                        else:
                            NewLabel = Elem1[0]
##                        if len(Nums) > 0:
##                            NewLabel = "Phi" + str(Nums[0])
##                        else:
##                            NewLabel = "Phi"
####                        print "NewLabel", NewLabel
####                        NewLabel = "Phi"
                        
                        NewMerged.append(NewLabel)
##                        NewMerged.append("Phi")
                        NewMerged.append(Elem1)
                        NewMerged.append(Elem2)
##                        print "NewMerged", NewMerged
 
                        self.Output_L.append(("Description:Label(Strengthened)",str(NewMerged)))
                        
                        
                        return NewMerged
                
                else:
                    print "Only Person"
                    print "Merged", Merged
                    sys.exit()

            elif "UErg" in str(Elem1Feats):
                NewMerged = []
                NewLabel = Elem1[0]
                NewMerged.append(NewLabel)
                NewMerged.append(Elem1)
                NewMerged.append(Elem2)
##                        print "NewMerged", NewMerged
                
                self.Output_L.append(("Description:Label(Strengthened)",str(NewMerged)))
                return NewMerged

        
        if "Copy" in Elem1Feats:
            if "Copy" not in Elem2Feats:
##                print "Label", Merged
                if "Root" in str(Elem2Feats):
                    Weak = True
                if Weak == True:
                    if "iPerson" in str(Elem2Feats):
                        if "iNumber" in str(Elem2Feats):
                            if "iGender" in str(Elem2Feats):
##                        print "Label", Merged
                                NewMerged = []
                                NewLabel = Elem2[0]
                                NewMerged.append(NewLabel)
                                NewMerged.append(Elem1)
                                NewMerged.append(Elem2)
##                        print "NewMerged", NewMerged
                                self.Output_L.append(("Description:Label(Move)",str(NewMerged)))
##                                print "Labeled via Movement", NewMerged
##                                print "\n\n\n"
##                                print "NewMerged2", NewMerged
##                                sys.exit()
                        
                                return NewMerged
                else:
##                    print "LDescription:Label(MoveAbel here", Merged

                    NewMerged = []
                    NewLabel = Elem2[0]
                    NewMerged.append(NewLabel)
                    NewMerged.append(Elem1)
                    NewMerged.append(Elem2)
##                        print "NewMerged", NewMerged
                    self.Output_L.append(("Description:Label(Move)",str(NewMerged)))
##                    print "Labeled via Movement222", NewMerged
##                    print "\n\n\n"
                    
                        
                    return NewMerged

                            

##        print "Elem2Feats", Elem2Feats
        if "Copy" in Elem2Feats:
            if "Copy" not in Elem1Feats:
##                print "Label", Merged
                if "Root" in str(Elem1Feats):
                    Weak = True
                if Weak == True:
                    if "iPerson" in str(Elem1Feats):
                        if "iNumber" in str(Elem1Feats):
                            if "iGender" in str(Elem1Feats):
##                        print "Label", Merged
                                NewMerged = []
                                NewLabel = Elem1[0]
                                NewMerged.append(NewLabel)
                                NewMerged.append(Elem1)
                                NewMerged.append(Elem2)
##                        print "NewMerged", NewMerged
                                self.Output_L.append(("Description:Label(Move)",str(NewMerged)))
##                                print "NewMerged33", NewMerged
                        
                                return NewMerged




                #Check to see if Elem2 can label
##                sys.exit()
##
##        if "Copy" in Elem2Feats:
##            if "Copy" not in Elem1Feats:
##                
##                if Elem2[0] == "_":
##                    True
##                else:
##                    
##                    print "Label22", Merged
##                    sys.exit()               

        
        for F in Elem1Feats:
            if F in Elem2Feats:
                SharedFeats.append(F)
        if SharedFeats == []:
            #Check for strengthened element
           
                                             
            
            return False
##        if self.Language == "Japanese":
##            return False
        if "iPerson" in str(SharedFeats):
            
            if "iNumber" in str(SharedFeats):
                if "iGender" in str(SharedFeats):
                    for Elem1F in SharedFeats:
                        if "iPerson" in Elem1F:
                            Nums = re.findall(NumPattern,Elem1F)
                               
 
##                        NewLabel = Elem1[0]
                            if self.Language == "Japanese":
                                
 
                            
                                NewLabel = Merged[-1][0]
                            else:



                                if len(Nums) > 0:
                                    NewLabel = "Phi" + str(Nums[0])
                                else:
                                    NewLabel = "Phi"
                            
                    NewMerged = []
##                    print "PhiPhi"
##                    sys.exit()
                    
##                    NewMerged.append("Phi")
                    NewMerged.append(NewLabel)
                    NewMerged.append(Elem1)
                    NewMerged.append(Elem2)
                    if self.Language == "Japanese":
                        self.Output_L.append(("Description:Label(Strengthened)",str(NewMerged)))
                    else:
                        self.Output_L.append(("Description:Label(SharedFeats)",str(NewMerged)))
##                    print "Label via shared FEatures333", NewMerged
##                    print "\n"

                    return NewMerged

            else:
##                print "Person only", Merged
                NewLabel = "Per"
                NewMerged = []
##                    print "PhiPhi"
##                    sys.exit()
                    
##                    NewMerged.append("Phi")
                NewMerged.append(NewLabel)
                NewMerged.append(Elem1)
                NewMerged.append(Elem2)
                self.Output_L.append(("Description:Label(SharedFeats)",str(NewMerged)))
                return NewMerged


                        

                
        
        return False
                

        
                



##        
##    def LabelCheckOld(self,Merged):
####        print "LAbelCheck"
####        print "MErged", Merged
####        print "OldStack", self.Stack
##
##        
##        MergedPosits = []
##        if self.SubStream == False:
##            if Merged in self.Stack:
##                
##                ctr = 0
##                while ctr < len(self.Stack):
##                    Current = self.Stack[ctr]
##                
##                    if Current == Merged:
##                        MergedPosits.append(ctr)
##                    ctr += 1
##                
##                
##            Label(Shared
##            
##            
####        if Merged in self.Stack:
####            print "Stack222"
####            print "\n\n"
##      
##        
##        if Merged[0] == "_":
##            Elem1 = Merged[1]
##            if Elem1[0] == "_":
##                return False
##            Elem2 = Merged[2]
##            if Elem2[0] == "_":
##                return False
##            Elem1Feats = self.GetHeadFeatures(Elem1)
##            Elem2Feats = self.GetHeadFeatures(Elem2)
##
##            SharedFeats = []
##            for F in Elem1Feats:
##                if F in Elem2Feats:
##                    SharedFeats.append(F)
##            if self.Language == "Japanese":
##                True #no labeling via shared features - except for semantics ???
##            elif SharedFeats != []:
##                if "iPerson" in str(SharedFeats):
##                    if "iNumber" in str(SharedFeats):
##                        if "iGender" in str(SharedFeats):
##                            #Shared phi
##                            NewMerged = []
##                            NewMerged.append("Phi")
##                            NewMerged.append(Elem1)
##                            NewMerged.append(Elem2)
####                            print "LabelShared", NewMerged
####                            print "!!!!!!!\n\n\n"
####                            print "Description6Shared", Merged
##                            self.Output_L.append(("Description:Label(SharedFeats)",str(NewMerged)))
##                            print "Label via shared FEatures", NewMerged
##                            print "\n"
####                            print "OldStack", self.Stack
##                            if MergedPosits != []:
##                                if self.SubStream == False:
##                                    NewStack = []
##                                    ctr = 0
##                                    while ctr < len(self.Stack):
##                                
##                                        if ctr not in MergedPosits:
##                                            Current = self.Stack[ctr]
##                                            NewStack.append(Current)
##                                        else:
##                                            NewStack.append(NewMerged)
##                                        ctr += 1
##                                   
##                                    self.Stack = NewStack
##                            for StackElem in self.Stack:
##                                 if StackElem == Merged:
##                                     print "Replace", StackElem
##                                     sys.exit()
####                            print "Stack after Shared LAbel"
####                            for elem in self.Stack:
####                                print "elem", elem
####                            print "7777\n\n"
##                                
##                                        
##                                    
##                                
## 
## 
####                            ctr = 0
####                            
####                            for elem in self.Stack:
####                                if elem == Merged:
####                                    TempStack.append(NewMerged)
####                                    
####                                else:
####                                    TempStack.append(elem)
####                            if TempStack != self.Stack:
######                                print "Old Stack", self.Stack
######                                print "\n\n"
####                                self.Stack = TempStack
####                                print "NewStack", NewStack
####                                sys.exit()
####                                    print "Found it", Merged
####                                    sys.exit()
####                                print "!!!elem", elem
####                            print "\n\n"
####                            
####                            if Merged in self.Stack:
####                                print "Found here"
####                                print "Merged", Merged
####                                sys.exit()
####                            print "LabelCheck Output", NewMerged
####                            print "NEwStack", self.Stack
####                            print "\n\n"
##                            return NewMerged
##                elif "iQ" in str(SharedFeats):
##                    NewMedef GetHeadFeaturesrged = []
##                    NewMerged.append("Q")
##                    NewMerged.append(Elem1)
##                    NewMerged.aLabel(Sharedppend(Elem2)
####                    print "Description7", NewMerged
####                    print "WHATTTTT"
####                    print "\n\n"
##                    self.Output_L.append(("Description:Label(SharedFeats)",str(NewMerged)))
##                    return NewMerged
##        return False

    def GetHeadFeaturesHeadFinal(self,Merged):
        
##        print "GetHEadFeaturesIndex"
##        print "XPList", XPList
         ##This function finds the head features of a phrase
##        print "GetHeadFeatures"
        if len(Merged) == 2:
            if type(Merged[0]) != list:
                if type(Merged[1]) == list:
                    HeadFeats = Merged[-1]
                    return HeadFeats
        if Merged[0] == "_":
            Head = self.GetHead(Merged[-1])
        else:
            Head = self.GetHead(Merged)
        ctr = len(Merged) - 1
        Cont = True
        while Cont == True:
            Current = Merged[ctr]
            CurrentHead = Current[0]
            if CurrentHead == Head:
                HeadFeats = self.GetHeadFeaturesHeadFinal(Current)
                return HeadFeats
            if len(Current) == 2:
                if type(Current[-1]) == list:
                    HeadFeats = Current[-1]
                    return HeadFeats
            else:
                ListPres = False
                for F in Current:
                    if type(F) == list:
                        ListPres = True
                if ListPres == False:
                    HeadFeats = Current
                    return Current
            ctr -= 1
            if ctr < 0:
                print "Error"
                print "Can't find head feats"
                sys.exit()
            
            



        
    def GetHeadFeatures(self,Merged):
        if self.Language == "Japanese":
##            print "GetHEadFEatures", Merged
            if "kiPerson" in str(Merged):
                print "error"
                print "Merged", Merged
                sys.exit()
            HeadFeats = self.GetHeadFeaturesHeadFinal(Merged)
##            if type(Result[-1]) == list:
##                HeadFeats = Result[-1]
##            else:
##                HeadFeats = Result
##            print "HeadFeats", HeadFeats
            
            return HeadFeats
            
        MergedFeats = False
        if Merged[0] == "_":
            MergedFeats = self.GetHeadFeatureFunct(Merged[1])
        else:
            if len(Merged) > 2:
                if Merged[2][0] == "_":
                    MergedFeats = self.GetHeadFeatureFunct(Merged[1])
            if MergedFeats == False:
                MergedFeats = self.GetHeadFeatureFunct(Merged)
        return MergedFeats
        
    def GetHeadFeatureFunct(self,Merged):
##        print "GetHEadFeats"
##        print "Merged", Merged
####        print type(Merged)
        
##        print "\n\n\nGetHEadFeatures"
##        print "RelevantStructure", Merged
##        print type(Merged)
##        if type(Merged) != list:
##            print "ERROR"
##            sys.exit()
##        
##        print "XPList", XPList
         ##This function finds the head features of a phrase
##        print "GetHeadFeatures"
        
        ListPresent = False
        HeadMerged = Merged[0]
        if HeadMerged == "_":
            return False
##            Target = Merged[1]
##            Merged = Target
##            HeadMerged = Merged[0]
        
            
            
##        print "Head", HeadMerged
        LIHeadPrev = "NONE"
        Temp = Merged[-1]
        for LI in Temp:
##            print "LI", LI
            LIHead = LI[0]
##            print "LIHead", LIHead
##            print "HeadMerged", HeadMerged
##            print "LI", LI
            
            if type(LI) == list:
                ListPresent = True
        if ListPresent == False:
            HeadFeatures = Temp
            
##            print "Found HeadFeatures"
##            print "Merged", Merged
##            print "HeadFeatures", HeadFeatures
##            print "!!!!33"
##            if type(Temp) == str:
##                MergedL = eval(Merged)
##                HeadFeatures = MergedL[-1]
##                print "HeadFeatures", HeadFeatures
##                sys.exit()
##            print "HeadFeatures!1111", HeadFeatures  
            return HeadFeatures
        
        Head = self.GetHead(Merged)
        HeadN = self.CleanLabelBasic(Head)
##        if "+" in HeadN:
##            #assume label is element after "+":
##            start = HeadMerged.index("+")
##            TempHead = HeadMerged[start+1:]
##            HeadN = TempHead
            

        for LI in Merged:
            if type(LI) != list:
                True #skip the head
            else:
                Head_LI = LI[0]
                if Head_LI == HeadN:
                    HeadFeaturesTemp = self.GetHeadFeatures(LI)
##                    
                    return HeadFeaturesTemp
                
        ##nothing found #second Merged
        for LI in Merged:
            if type(LI) != list:
                True #skip the head
            else:
                Head_LI = LI[0]
                if Head_LI == Head:
                    HeadFeatures = self.GetHeadFeatures(LI)
##                    print "HeadFeatures!!44444", HeadFeatures

                    return HeadFeatures
        #Look for shared features
        if Merged[0] in SharedFeatLabels:
            Elem1 = Merged[1]
            Elem1Feats = self.GetHeadFeatures(Elem1)
            Elem2 = Merged[2]
            Elem2Feats = self.GetHeadFeatures(Elem2)
            SharedFeats = []
            for F in Elem1Feats:
                if F in Elem2Feats:
                    SharedFeats.append(F)
            if SharedFeats != []:
                
                return SharedFeats
        if "Phi" in HeadMerged:
##            print "Merged", Merged
            HeadFeatures = self.GetHeadFeatures(Merged[1])
##            print "HeadFeatures", HeadFeatures
            return HeadFeatures


    def CleanLabelBasic(self,Label):
##        print "CleanLabelBasic"
##        print "Label", Label
        temp1 = re.sub("_PhEdg", '', Label)
        temp2 = re.sub("_AdjNd", '', temp1)
        temp3 = re.sub("_RENUM", '', temp2)
        temp4 = re.sub("_Set", '', temp3)
        temp5 = re.sub("\(Copy\)",'', temp4)
        NewLabel = temp5
##        print "NewLabel", NewLabel
        return NewLabel

    def GetHead(self, Merged):
        #this will find the head of a Merged syntactic object. The head is a string, and shouldn't have
        #any brackets
        
        for LI in Merged:
            if type(LI) != list:
                Head = LI
##                print Head
                return Head
            
        print "Error: No Head found"
        sys.exit()
##    def PhaseComputations(self,Merged):
##        #Check for phase operations
##        print "Phase level Comps"
##        print "Merged", Merged
##        #phase head passes all uFs down until they are checked
##        StackTop = self.Stack[-1]
##        print "StackTop", StackTop
##        
##        HeadFeats = self.GetHeadFeatures(StackTop)
##        print "HeadFeats", HeadFeats
##        uFs = []
##        for F in HeadFeats:
##            if F[0] == "u":
##                uFs.append(F)
##        if uFs == []:
##            return False
##        
##        Cont = True
##        print "uFs", uFs
##        
##        
##        sys.exit()
        

##        while Cont == True:
            
        
        
        True
    
           
            

        
        
    def FindSharedFeatures(self,X,Y):
        SharedFs = []
##        print "X", X
##        print "Y", Y
        XHeadFeats = self.GetHeadFeatures(X)
        YHeadFeats = self.GetHeadFeatures(Y)

        for Feat in XHeadFeats:
            if Feat in YHeadFeats:
                SharedFs.append(Feat)
        return SharedFs
        
        
    def UncheckFeatCheck(self,Elem):
##        print "UncheckedFeatCheck"
##        print "Elem", Elem
        pattern = r'u[A-Z]'

        m = re.findall(pattern,str(Elem))
        if len(m) > 0:
            return True
        else:
            return False
                            
##    def MinimalSearch(self,Merged):
##        print "MinimalSearch"
##        print "Merged", Merged
##        #Do the following
##
##        #1 Pass uFs from phase head down the tree until Agreement relations are possible
##        #2 label projections when possible
##        #3 clear stack corresponding to complement of phase head
##
##        
##        LabelFeats = self.GetHeadFeatures(Merged)
##        print "LabelFeats", LabelFeats
##        sys.exit()
##        ctr = len(self.Stack) - 1
##        PoppedElements = []
##        Label= False
##        CopyMerged = True
##        MovedXPs = [] #create a list of moved XPs to check to see if an XP has moved out of a YP
##
##        #Ways for labeling
##        #1: Head Merges with non-head
##        #2: [XP YP] - both heads and YP moves out - label is X
##        #3: [XP YP] where X and Y share features (phi, wh, etc)
##        while ctr > 0:
##            
####            print "Elem", Elem
##            Elem = self.Stack[ctr]
####            print "Elem11", Elem
##
##            ElemLabel = Elem[0]
##            HeadFeats = self.GetHeadFeatures(Elem)
####            print "Elem", Elem
##
##            MoveLabel = False
##            if ElemLabel ==  "_":
##                    
####                    print "Elem", Elem
##                LabdCtr = ctr - 1
##                LowerElem = self.Stack[LabdCtr]
##                if LowerElem in MovedXPs:
##                    SO1 = Elem[1]
##                    SO2 = Elem[2]
####                    print "SO1", SO1
####                    print "SO2", SO2
##                    if SO1[0] in AllHeads:
##                        MoveLabel = True
####                    elif SO2[0] in AllHeads:
####                        MoveLabel = True
##                    if MoveLabel == True:
##                        if SO1 in MovedXPs:
##                            Label = SO2[0]
##                        elif SO2 in MovedXPs:
##                            Label = SO1[0]
##                        else:
##                            print "Can't determine label"
##                            sys.exit()
##                        NewElem = []
##                        NewElem.append(Label)
##                        NewElem.append(SO1)
##                        NewElem.append(SO2)
##                    
####                    NewElem += Elem[1:]
####                    NewM = []
####                    NewM.append(Label)
####                    NewM.append(LowerElem)
####                    NewM.append(NewElem)
##                        print "NewElem", NewElem
##                        NewMerged = self.ReplaceElemInString(str(Merged),str(Elem),str(NewElem))
##                        Merged = eval(NewMerged)
##                        print "Merged", Merged
##
##                    
##                    
##
##                    
####                    sys.exit()
##                    ###label
##                if MoveLabel == False:                      
##                    Found = False
##                    while Found == False:
##                        LowerElem = self.Stack[LabdCtr]
##                    
##                        LowerElemLabel = LowerElem[0]
##                        if LowerElemLabel != "_":
##                            Found = True
##                        else:
##                            LabdCtr -= 1
##                    
##                
## 
##                        #MErge
##                    SharedFs = self.FindSharedFeatures(Elem,LowerElem)
####                    print "SharedFs", SharedFs
##                    
##                    PhiPres = False
##                    for F in PhiFeats:
##                        if F in str(SharedFs):
##                            PhiPres = True
##    ##                    print "PhiPresent", PhiPres
##                    if PhiPres == True:
##                        Label = "Phi"
##                    else:
####                        print "Merged", Merged
##                        print "can this be labeled another way?"
##                        sys.exit()
##  
##
##
##                    MovedXPs.append(LowerElem)
##                    NewElem = []
##                    NewElem.append(Label)
##                    NewElem += Elem[1:]
##                    NewM = []
##                    NewM.append(Label)
##                    NewM.append(LowerElem)
##                    NewM.append(NewElem)
##
##                        
##                    NewMerged = self.ReplaceElemInString(str(Merged),str(Elem),str(NewM))
##                    Merged = eval(NewMerged)
##                
##                      
##                self.Output_L.append(("Description:UnlabeledM",str(Merged)))
##                Label = False
####                else:
####                    ctr -= 1
######                    ctr = 0
####                    
######                    print "\n"
######                    sys.exit()
####
#### 
######            print "HeadFeats", HeadFeats
####
####            else:
##                                       
##            ctr -= 1
##    
##        
##        #Clear out stack --- and
##        ####label any unlabeled elements
##        UnchkdFeatCtr = 0
##        for StackElem in self.Stack:
##            
##            if StackElem != LowerElem:
##                StackElemLabel = StackElem[0]
##                if StackElemLabel == "_":
##                    if StackElem != Elem:
##                        if StackElem != LowerElem:
##                           
##                            if str(StackElem) in str(Merged):
####                                print "Found it"
####                                print "StackElem", StackElem
####                                print "NewMerged", Merged
##
##                                StackElemX = StackElem[1]
##                    
##                                StackElemY = StackElem[2]
##                                NewLabel = False
##                                if StackElemX == LowerElem:
##                                    NewLabel = StackElemY[0]
##                                elif StackElemY == LowerElem:
##                                    NewLabel = StackElemX[0]
##                                else:
##                                    print "Determine Label Error 456"
##                                    sys.exit()
####                                print "NewLabel", NewLabel
##                                NewStackElem = []
##                                NewStackElem.append(NewLabel)
##                                NewStackElem += StackElem[1:]
####                                print "NewStackElem", NewStackElem
##     
##                                TempMerged = self.ReplaceElemInString(str(Merged),str(StackElem),str(NewStackElem))
##
####                                NewLowerElem = self.CopyForm(str(LowerElem))
####                                print "NewLowerElem", NewLowerElem
####                                TempMerged1 = self.ReplaceElemInString(str(TempMerged),str(LowerElem),str(NewLowerElem))
##
##                                
##                                Merged = eval(TempMerged)
####                                print "Label after Move!!!!!!!$$$$$"
##                                self.Output_L.append(("Description:LbAfterMove",NewLabel))
##
##                                self.Output_L.append(("Description:LbM",str(Merged)))
##
##            HeadFeats = self.GetHeadFeatures(StackElem)
##            
##            Output = self.UncheckFeatCheck(HeadFeats)
####            print "Output", Output
##            if Output == False:
##                UnchkdFeatCtr += 1
##            else:
##                True
####        print "LenStack", len(self.Stack)
####        print "Unchecked", UnchkdFeatCtr
##        if len(self.Stack) == UnchkdFeatCtr:
##            self.Output_L.append(("Description:ClearStack",str(self.Stack)))
##            self.Stack = []
##
##        else:
##            print "Feature Error 4567"
##  
##       
##                
####        print "Merged", Merged
####        print "\n"
##        return Merged                   

            
        

        
       
                             
                             
    def GetForm(self,SO):
        #"MergeF" is a feature that is deleted upon Merged
        #used to keep track of whether or not an element has undergone first MErge
        #can distinguish an X (simple) from an XP (complex)
        
        #put elements with uFs right onto the stack
        UncheckedFeats = False
        if SO == "v*":
            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)
            Case = "Case:Acc" + str(self.FeatCtr)
            LI = [SO,[uPerson,uNumber,uGender,"MergeF","Head",Case]]
            UncheckedFeats = True
##            self.Stack.append(LI)

        elif SO == "C":
            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)
            Case = "Case:Nom" + str(self.FeatCtr)
            LI = [SO,[uPerson,uNumber,uGender,"MergeF","Head",Case]]
            
            UncheckedFeats = True

        elif SO == "P_in":
            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)
            Case = "Case:Dat" + str(self.FeatCtr)
            LI = [SO,[uPerson,uNumber,uGender,"MergeF","Head",Case]]

            
        elif SO == "that":
            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)
            Case = "Case:Nom" + str(self.FeatCtr)
            LI = [SO,[uPerson,uNumber,uGender,"MergeF","Head","iC",Case]]
            
            UncheckedFeats = True

        elif SO == "C_Q":
            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)
            Case = "Case:Nom" + str(self.FeatCtr)
            LI = [SO,[uPerson,uNumber,uGender,"MergeF","Head",Case,"uQ","iScp","iC"]]

        

            
        elif SO == "C_Top":
            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)
            Case = "Case:Nom" + str(self.FeatCtr)
            LI = [SO,[uPerson,uNumber,uGender,"MergeF","Head",Case,"uTop","iScp","iC"]]

            
        elif SO == "C_Null":#Special C that deletes - resulting in dephasing
            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)
            Case = "Case:Nom" + str(self.FeatCtr)
            LI = ["C",[uPerson,uNumber,uGender,"MergeF","Head",Case,"Delete","iC"]] 

            
        elif SO == "v":

            LI = [SO,["MergeF","Head","iv"]]
            UncheckedFeats = True
        elif SO == "v_be":
            self.FeatCtr += 1
            Root = "Root" + str(self.FeatCtr)
##
####            LI = [SO,["MergeF","Head","iv","UErg"]]
            LI = [SO,["MergeF","iv",Root]]
            UncheckedFeats = True
            
        elif SO == "vUnerg":
            self.FeatCtr += 1
            Root = "Root" + str(self.FeatCtr)
##
####            LI = [SO,["MergeF","Head","iv","UErg"]]
            LI = [SO,["MergeF","iv",Root]]
            UncheckedFeats = True
           

        elif SO == "v~":

                LI = ["v~",["MergeF","ThetaAgr"]]

        elif SO == "n_Top":
            self.FeatCtr += 1
            iTop = "iTop" + str(self.FeatCtr)
            uScp = "uScp" + str(self.FeatCtr)
##            LI = ["D",["MergeF","Head","uPhi",iTop,uScp]]

            self.PhiCtr += 1
            PhiPerson = "iPerson:" + str(self.PhiCtr)
            PhiNumber = "iNumber:" + str(self.PhiCtr)
            PhiGender = "iGender:" + str(self.PhiCtr)
            self.FeatCtr += 1
            uCase = "uCase" + str(self.FeatCtr)


##                       LI = [SO,["MergeF","Head","uPhi","iD"]]
##            UncheckedFeats = True
            Features = [PhiPerson,PhiNumber,PhiGender,"MergeF",uCase,"iTheta","Head","iN","iD",iTop,uScp]
           
                

##            
##            LI = [SO,[PhiPerson,PhiNumber,PhiGender,"MergeF",uCase,"iTheta","Head","iN"]]
            LI = [SO]
            LI.append(Features)


            
            UncheckedFeats = True



            
            
        elif SO == "n":
            
            self.PhiCtr += 1
            PhiPerson = "iPerson:" + str(self.PhiCtr)
            PhiNumber = "iNumber:" + str(self.PhiCtr)
            PhiGender = "iGender:" + str(self.PhiCtr)
            self.FeatCtr += 1
            uCase = "uCase" + str(self.FeatCtr)


##                       LI = [SO,["MergeF","Head","uPhi","iD"]]
##            UncheckedFeats = True
            if self.Language == "Japanese":
                Features = [PhiPerson,PhiNumber,PhiGender,"MergeF",uCase,"iTheta","Head","iN","iD"]
            else:
                Features = [PhiPerson,PhiNumber,PhiGender,"MergeF",uCase,"iTheta","Head","iN"]
           
                

##            
##                LI = [SO,[PhiPerson,PhiNumber,PhiGender,"MergeF",uCase,"iTheta","Head","iN"]]
            LI = [SO]
            LI.append(Features)


            
            UncheckedFeats = True
        elif SO == "n_Expl":


            self.FeatCtr += 1
            uPerson = "uPerson" + str(self.FeatCtr)
            uNumber = "uNumber" + str(self.FeatCtr)
            uGender = "uGender" + str(self.FeatCtr)

            
##            self.FeatCtr += 1
##            uPerson = "uPerson" + str(self.FeatCtr)

##            
##            self.PhiCtr += 1
##            PhiPerson = "iPerson:" + str(self.PhiCtr)
##            PhiNumber = "iNumber:" + str(self.PhiCtr)
##            PhiGender = "iGender:" + str(self.PhiCtr)
##            self.FeatCtr += 1
##            uCase = "uCase" + str(self.FeatCtr)


##                       LI = [SO,["MergeF","Head","uPhi","iD"]]
##            UncheckedFeats = True
            Features = [uPerson,uNumber,uGender,"MergeF","Head","iN"]
           
                

##            
##            LI = [SO,[PhiPerson,PhiNumber,PhiGender,"MergeF",uCase,"iTheta","Head","iN"]]
            LI = ["n"]
            LI.append(Features)


            
            UncheckedFeats = True





        elif SO == "there":
            LI = ["there",["MergeF","ThetaAgr"]]

        elif SO in DetHeads:
            LI = [SO,["MergeF","Head","uPhi","iD"]]
            UncheckedFeats = True

            
        elif SO == "Q":
            self.FeatCtr += 1
            iQ = "iQ" + str(self.FeatCtr)
            uScp = "uScp" + str(self.FeatCtr)
            LI = [SO,["MergeF","Head","uPhi",iQ,uScp]]
            
 

            

        elif SO == "which":
            self.FeatCtr += 1
            iQ = "iQ" + str(self.FeatCtr)
            uScp = "uScp" + str(self.FeatCtr)
            LI = [SO,["MergeF","Head","uPhi",iQ,uScp]]
            
            

            
        else:
            self.FeatCtr += 1
            Root = "Root" + str(self.FeatCtr)
            Feats = ["MergeF",Root]
            LI = [SO,Feats]


##        if UncheckedFeats == True:
##            NewFeats = self.CheckFeats(LI)

##        if UncheckedFeats == True:
##            self.Stack.append(LI)
            
##            sys.exit()
            
##        self.Stack.append(LI)
        
        
        return LI

            

        
    def RemoveFirstMergeMarker(self,Feats):
        NewFeats = []
        for F in Feats:
            if F == "MergeF":
                True
            else:
                NewFeats.append(F)
        return NewFeats
                        
    def CheckFeats(self,X,Y):
##        print "CheckFeats"
##        print "X", X
##        print "Y", Y
        
        



                    
        #If X has uPhi, then uPhi are passed down the tree until they are checked
       
        if X[0] == "_":
            XFeats = self.GetHeadFeatures(X[1])
       
        else:
            XFeats = self.GetHeadFeatures(X)

            
        if Y[0] == "_":
            YFeats = self.GetHeadFeatures(Y[1])
        elif Y[0] in SharedLabels:
            YFeats = self.GetHeadFeatures(Y[1])
            
##            print "YFeats", YFeats
            
        else:
            if len(Y) > 2:
                if Y[2][0] == "_":
                    print "problem"
                    print "Y", Y
                    sys.exit()
                   
            YFeats = self.GetHeadFeatures(Y)
        
##        print "X", X
##        print "Y", Y
##        print "XFeats", XFeats
##           
##        else:
##            if len(Y) > 2:
##                if Y[2][0] == "_":
##                    print "problem"
##                    sys.exit()
##            YFeats = self.GetHeadFeatures(Y)
##        print "YFeats", YFeats
        CurrentLabel = False
        
        if "Head" in XFeats:
            if "Head" in YFeats:
                print "Both are heads"
                print "Figure out label"
                print "%%%%"
                sys.exit()
            else:
                CurrentLabel = X[0]
        elif "Head" in YFeats:
            CurrentLabel = Y[0]
        if CurrentLabel != False:
            PrintMerge = []
            PrintMerge.append(CurrentLabel)
            if self.Language == "Japanese":
                PrintMerge.append(Y)
                PrintMerge.append(X)
            else:
                PrintMerge.append(X)
                PrintMerge.append(Y)
            self.Output_L.append(("Description:Label(Head)",str(PrintMerge)))
##            print "MergedHere", PrintMerge
##            print "\n\n"


            
        Inherit = False
        uPhi = []
        for F in XFeats:
            if "uPerson" in F:
                uPhi.append(F)
            elif "uNumber" in F:
                uPhi.append(F)
            elif "uGender" in F:
                uPhi.append(F)
            elif "Case" in F:
                if "uCase" not in F:
                    uPhi.append(F)
            elif "UErg" in F:
                uPhi.append(F)
            else:
                True
        if len(uPhi) >= 3:
            Inherit = X
        elif X[0] in PhaseHeads:
            Inherit = X
        elif "UErg" in XFeats:
            Inherit = X
            
            
        if Inherit == False:
            for F in YFeats:
                if "uPerson" in F:
                    uPhi.append(F)
                elif "uNumber" in F:
                    uPhi.append(F)
                elif "uGender" in F:
                    uPhi.append(F)
                elif "Case" in F:
                    if "uCase" not in F:
                        uPhi.append(F)
                else:
                    True
            if len(uPhi) >= 3:
                Inherit = Y

##        print "uPhi", uPhi
##        print "\n"
        PassedL = []
        FeatsPassed = False
        Prev = False #block feature passage to nominal
        if Inherit != False:
            Pass = False
            
            
            PhaseHead = X[0]
            
            #pass feats down the tree
            if self.SubStream == False:
                Cont = True
                StackCtr = len(self.Stack) - 1
                    
                while Cont == True:
                    
                    Current = self.Stack[StackCtr]
                    if Current == X:
                        StackCtr -= 1
                        Current = self.Stack[StackCtr]
##                    print "Current", Current
##                    print "Current", Current
                    CurrentFeats = self.GetHeadFeatures(Current)
##                    print "CurrentFeats", CurrentFeats
##                    print "PassedL", PassedL
##                    print "Current", Current
##                    print "CurrentFeats", CurrentFeats
##                    print "\n\n"
##                    if Current[0] in SharedLabels:
##                        print "Shared", Current
##                        print "CurrentFeats", CurrentFeats
##                        print "\n\n\n"
                    
                    
                    
                    if "Root" in str(CurrentFeats):
                        
##                        Pass = True
                        if "uPerson" not in str(CurrentFeats):
                            if "iPerson" not in str(CurrentFeats):
                                if Current not in PassedL:
                                    if "iD" not in str(CurrentFeats):
                                        if "iN" not in str(CurrentFeats):
                                            if Prev != "n":
                            
                                                PassedL.append(Current)
##                                                print "Pass true"
##                                                print "current", Current
##                                                print "currentFeats", CurrentFeats
##                                                print "\n\n"
                                                if Current[0] != "_":
                                                    OtherLabel = Current[0]
                                                else:
                                                    if Current[1][0] != "_":
                                                        if self.Language == "Japanese":
                                                            OtherLabel = Current[-1][0]
                                                        else:
                                                            OtherLabel = Current[1][0]
                                                    elif Current[2][0] != "_":
                                                        if self.Language == "Japanese":
                                                            OtherLabel = Current[-2][0]
                                                        else:
                                                        
                                                            OtherLabel = Current[2][0]
                                                    else:
                                                        print "error - can't find label9999"
                                                        sys.exit()
##                                                print "Pass is true", Current
##                                                print "\n\n"
                                                Pass = True
##                                            else:
##                                                print "Prev is n", PRev
##                                                sys.exit()
##                    if FeatsPassed == True:
##                        if Pass == False:
##                            if "iD" in str(CurrentFeats):
##                                
##                                if Current[2][0] != "_":
##                                    print "Current", Current
##                                    sys.exit()
##                                    Cont = False
                    Prev = Current[0]
                               
##                    if Pass == False:
##                        if "iv" in str(CurrentFeats):
##                            Cont = False
##                        elif "iC" in str(CurrentFeats):
##                            Cont = False
##                        elif "iPerson" in str(CurrentFeats):
##                            Cont = False
                        

                        

                    if Pass == True:
                            
                        NewFeats = CurrentFeats + uPhi
                        NewCurrent = self.ReplaceFeats(Current,CurrentFeats,NewFeats)
                        PhaseHead = Inherit[0]
            ##                        print "PhaseHead", PhaseHead
            ##                        print "Other", Current[0]
            ##                        sys.exit()
                        
##                        print "pass to Other", NewCurrent
                        PassedLabels = "Pass Features " + PhaseHead + " to " + OtherLabel
##                        print "PassedLabes", PassedLabels
##                        print "NewCurrent", NewCurrent
##                        print "Current", Current
##                        print "\n"
                        self.Output_L.append(("Description:PassFs",PassedLabels))
                        PassedFs = " ".join(uPhi)
                        self.Output_L.append(("Description:FeaturesPassed",PassedFs))
                        self.InheritanceCtr += 1
##                        print "Pass FEatures", PassedLabels
##                        print "\n\n"
    ##                    else:
    ##                        Cont = False


                                    
                        if str(Current) in str(Y):
                            NewY = self.ReplaceElemInString(str(Y),str(Current),str(NewCurrent))
                            Y = eval(NewY)
##                            print "NewY", Y
##                            sys.exit()
                        FeatsPassed = True
##                        print "Next", self.Stack[StackCtr-1]
                        Pass = False
##                        if self.SubStream == False:
##                            Next = self.Stack[StackCtr-1]
##                            NextFeats = self.GetHeadFeatures(Next)
##                            if "iD" in str(NextFeats):
##                                Cont = False
##                                print "Next", Next
##                                sys.exit()
                    
 
                        #Find       element that contains NewCurrent
##                        print "X", X
##                        print "Y", Y
##                        print "STack"
##                        for elem in self.Stack:
##                            print "elem", elem
##                        Cont = False
                    
                    StackCtr -= 1
                    if StackCtr < 0:
                        Cont = False
##                print "CheckFeatFunct"
                (NewX, NewY,CheckedFeats) = self.CheckFeatFunct(X,Y)
                X = NewX
                Y = NewY
##                print "NewX", NewX
##                print "NewY", NewY
##                print "LAbelInput", Y
##                print "LabelInputType", type(Y)
                LabelOutput = self.LabelCheck(Y)
                if LabelOutput != False:
                    Y = LabelOutput
##                    print "LabelOutputType111", type(LabelOutput)
                    
                    Cont = False

                
                           
                    

            else:
##                print "pass feats down in substream"
                
                Cont = True
                StackCtr = len(self.SubStreamStack) - 1
                    
                while Cont == True:
                    
                    Current = self.SubStreamStack[StackCtr]
                    if Current == X:
                        StackCtr -= 1
                        Current = self.SubStreamStack[StackCtr]
##                    print "Current", Current
##                    print "Current", Current
                    CurrentFeats = self.GetHeadFeatures(Current)
##                    print "CurrentFeats", CurrentFeats
##                    print "PassedL", PassedL
##                    print "Current", Current
##                    print "CurrentFeats", CurrentFeats
##                    print "\n\n"
##                    if Current[0] in SharedLabels:
##                        print "Shared", Current
##                        print "CurrentFeats", CurrentFeats
##                        print "\n\n\n"
                    
                    
                    
                    if "Root" in str(CurrentFeats):
                        
##                        Pass = True
                        if "uPerson" not in str(CurrentFeats):
                            if "iPerson" not in str(CurrentFeats):
                                if Current not in PassedL:
                                    if "iD" not in str(CurrentFeats):
                                        if "iN" not in str(CurrentFeats):
                                            if Prev != "n":
                            
                                                PassedL.append(Current)
##                                                print "Pass true"
##                                                print "current", Current
##                                                print "currentFeats", CurrentFeats
##                                                print "\n\n"
                                                if Current[0] != "_":
                                                    OtherLabel = Current[0]
                                                else:
                                                    if Current[1][0] != "_":
                                                        if self.Language == "Japanese":
                                                            OtherLabel = Current[-1][0]
                                                        else:
                                                            OtherLabel = Current[1][0]
                                                    elif Current[2][0] != "_":
                                                        if self.Language == "Japanese":
                                                            OtherLabel = Current[-2][0]
                                                        else:
                                                        
                                                            OtherLabel = Current[2][0]
                                                    else:
                                                        print "error - can't find label9999"
                                                        sys.exit()
##                                                print "Pass is true", Current
##                                                print "\n\n"
                                                Pass = True

                    Prev = Current[0]
                               
#

                        

                    if Pass == True:
                            
                        NewFeats = CurrentFeats + uPhi
                        NewCurrent = self.ReplaceFeats(Current,CurrentFeats,NewFeats)
                        PhaseHead = Inherit[0]
            ##                        print "PhaseHead", PhaseHead
            ##                        print "Other", Current[0]
            ##                        sys.exit()
                        
##                        print "pass to Other", NewCurrent
                        PassedLabels = "Pass Features " + PhaseHead + " to " + OtherLabel
##                        print "PassedLabes", PassedLabels
##                        print "NewCurrent", NewCurrent
##                        print "Current", Current
##                        print "\n"
                        self.Output_L.append(("Description:PassFs",PassedLabels))
                        PassedFs = " ".join(uPhi)
                        self.Output_L.append(("Description:FeaturesPassed",PassedFs))
                        self.InheritanceCtr += 1
##                        print "Pass FEatures", PassedLabels
##                        print "\n\n"
    ##                    else:
    ##                        Cont = False


                                    
                        if str(Current) in str(Y):
                            NewY = self.ReplaceElemInString(str(Y),str(Current),str(NewCurrent))
                            Y = eval(NewY)
##                            print "NewY", Y
##                            sys.exit()
                        FeatsPassed = True
##                        print "Next", self.Stack[StackCtr-1]
                        Pass = False

                    
 
                        #Find       element that contains NewCurrent
##                        print "X", X
##                        print "Y", Y
##                        print "STack"
##                        for elem in self.Stack:
##                            print "elem", elem
##                        Cont = False
                    
                    StackCtr -= 1
                    if StackCtr < 0:
                        Cont = False
##                print "CheckFeatFunct"
                (NewX, NewY,CheckedFeats) = self.CheckFeatFunct(X,Y)
                X = NewX
                Y = NewY
##                print "NewX", NewX
##                print "NewY", NewY
##                print "LAbelInput", Y
##                print "LabelInputType", type(Y)
                LabelOutput = self.LabelCheck(Y)
                if LabelOutput != False:
                    Y = LabelOutput
##                    print "LabelOutputType111", type(LabelOutput)
                    
                    Cont = False
            
            
        
 

        else:
##            print "Funct Input", X                              
            (NewX, NewY,CheckedFeats) = self.CheckFeatFunct(X,Y)
##            print "FunctOutput"
            X = NewX
            Y = NewY
##            print "XXX", X

            
##            (NewY, NewX,CheckedFeats) = self.CheckFeatFunct(Y,X)
##            X = NewX
##            Y = NewY

 
                    


##            else:
##                print "Do def CheckFeatsin substream99999"
##                sys.exit()
            


##        print "CheckFeatsOutput"
##        print "X", X
##        print "Y", Y
##        print "\n"
        return (X,Y,FeatsPassed)




    def ReplaceFeats(self,Elem,OldFeats,NewFeats):
        
        
        NewElemTemp = self.ReplaceElemInString(str(Elem),str(OldFeats),str(NewFeats))
        NewElem= eval(NewElemTemp)
        if self.SubStream == False:
            NewStack = self.ReplaceEverywhere(self.Stack,str(OldFeats),str(NewFeats))
            self.Stack = NewStack
        else:
            NewSubStack = self.ReplaceEverywhere(self.SubStreamStack,str(OldFeats),str(NewFeats))
            self.SubStreamStack = NewSubStack
        
        return NewElem
        
    def CheckFeatFunct(self,X,Y):
##        print "CheckFeatFunct"
##        print "Y", Y
##        print "X", X
##        print type(Y)
##        print Y[0]
        
        if X[0] == "_":
            XFeats = self.GetHeadFeatures(X[1])
        else:
            XFeats = self.GetHeadFeatures(X)

        if Y[0] == "_":
            YFeats = self.GetHeadFeatures(Y[1])
##            print "YFeats", YFeats
        elif Y[0] in SharedLabels:
            YFeats = self.GetHeadFeatures(Y[1])
##            print "XFeats", XFeats
##            print "Y1111", YFeats
##            for elem in self.Stack:
##                print "StackElem", elem
##                print "\n"
           
        else:
            YFeats = self.GetHeadFeatures(Y)
##        print "YFeats1", YFeats
        CheckedFeatsTup = [] #tuple of previous unchecked features and newly checked features
        CheckedFeats = []

        
        #XFeats probe
 
                           
        if "MergeF" in XFeats:
            NewXFeats = []
            for F in XFeats:
                if F == "MergeF":
                    True
                else:
                    NewXFeats.append(F)
                              
            NewX = self.ReplaceFeats(X,XFeats,NewXFeats)
            X = NewX
            XFeats = NewXFeats

            if self.SubStream == False:
                NewStack = self.ReplaceEverywhere(self.Stack,str(XFeats),str(NewXFeats))
                self.Stack = NewStack
            else:
                NewSubStack = self.ReplaceEverywhere(self.SubStreamStack,str(XFeats),str(NewXFeats))
                self.SubStreamStack = NewSubStack

            
        Phi = False
        if "uPerson" in str(XFeats):
            if "uNumber" in str(XFeats):
                if "uGender" in str(XFeats):
                    Phi = True
            
 
 
        

        uFs = []
##        print "XFeats", XFeats
        for F in XFeats:
            if F[0] == "u":
               uFs.append(F)
            elif "Case" in F:
                if Phi == True:
                    uFs.append(F)
            elif "iScp" in F:
                uFs.append(F)
##        print "uFs", uFs               
##        if "uQ" in uFs:
##            print "uFs", uFs
##            print "XFeats", XFeats
##            print "uFs", uFs
##            print "Stack"
##            for elem in self.Stack:
##                print "elem", elem
##            print "Stack over"
##            print "\n\n"
        if self.SubStream == False:
            if self.Stack == []:
                return (X,Y)
            
        if uFs == []:
            True
       
        
        else:
##            print "try to check Features"
            pattern = r'[^1-9]+'
            uFpattern = r'u[A-Z][a-z]*'

            ####
            FeatCtr = 0
            if self.SubStream == False:
                
                StackCtr = len(self.Stack) - 1 #top element should be identical to probe
            else:
                StackCtr = len(self.SubStreamStack) - 1
                
            RemovedFeats = dict()
            Cont = True
            

            FeatCtr = 0
            NewXFeats = []
            CheckedX = False
##            print "uFs", uFs
            while FeatCtr < len(uFs):
                Skip = False
                
                
                FeatChecked  = False
##            while FeatCtr < len(uFs):
                
                F = uFs[FeatCtr]
                if F[0] != "u":
                    Skip = True
                
                    
                    
##                    print "uF", F
##                    print "Stack"
##                    for elem in self.Stack:
##                        print "elem", elem
##                    print "uQQQQQ!!!!\n\n"
##                    sys.exit()
                m = re.findall(pattern,F)
                Target = m[0]


                
                Goal = "i" + Target[1:]
##                if F == "uQ":
##                    print "F", F
##                    print "Goal", Goal
##                    print "\n\n"
##                print "Goal", Goal
                if self.SubStream == False:
                    StackTop = self.Stack[StackCtr]
                    if StackTop == X:
                        StackCtr -= 1
                        StackTop = self.Stack[StackCtr]
                else:
                    StackTop = self.SubStreamStack[StackCtr]
                    if StackTop == X:
                        StackCtr -= 1
                        StackTop = self.SubStreamStack[StackCtr]
##                print "StackTop", StackTop
                
                    

                if "Phi" in StackTop[0]:
                    #Don't look at the features of an element with shared phi-features
                    #This is maybe an imperfection
                    TopFeats = False
                else:
                    TopFeats = self.GetHeadFeatures(StackTop)
                    
##                TopFeats = self.GetHeadFeatures(StackTop)
##                if F == "uQ":
##                    print "F", F
##                    print "Goal", Goal
##                    print "StackTop", StackTop
##                    print "\n\n"
##                    print "TopFeats", TopFeats
##                print "\n"
                if TopFeats == None:
                    sys.exit()

                PhiChecked = False
                p = re.findall(uFpattern,str(TopFeats))
                if p != []:
                
                    uFPresent = False
                    uFPresent = True
                    
 
                    #Check for possibility of feature unification
                    #Avoid probing from non-root element at this time
                    UnifiedFeatsTemp = []
                    for TopFTemp in TopFeats:
##                        print "TopFeats", TopFeats
##                        TargetuFTemp1 = False
                        TargetTemp1 = re.findall(uFpattern,TopFTemp)
                        if TargetTemp1 != []:
                            TopFTemp = TargetTemp1[0]
                            if TopFTemp in F:
##                                print "TopFTemp", TopFTemp
##                                print "F", F
##                                print "TopFeats", TopFeats
                                #Find TargetuF
                                TargetuFTemp1 = False
                                for uF1 in TopFeats:
                                    if TopFTemp in uF1:
                                        TargetuFTemp1 = uF1
##                                        print "Found", TargetuFTemp1
                                    if TargetuFTemp1 != False:
                                        if TargetuFTemp1 != F:
                                            if F not in UnifiedFeatsTemp:
                                                UnifiedFeatsTemp.append(F)
                                            

                                                if self.SubStream == False:
                                                    NewStack = self.ReplaceEverywhere(self.Stack,TargetuFTemp1,F)
                                                    self.Stack = NewStack
                                                else:
                                                    NewSubStack = self.ReplaceEverywhere(self.SubStreamStack,TargetuFTemp1,F)
                                                    self.SubStreamStack = NewSubStack
                                                NewTopFeats = self.ReplaceEverywhere(TopFeats,TargetuFTemp1,F)
                                                TopFeats = NewTopFeats

                                                NewStackTop = self.ReplaceEverywhere(StackTop,TargetuFTemp1,F)
                                                StackTop = NewStackTop

                                                NewX = self.ReplaceEverywhere(X,TargetuFTemp1,F)
                                                X = NewX

                                                NewY = self.ReplaceEverywhere(Y,TargetuFTemp1,F)
                                                Y = NewY
                                                self.Output_L.append(("Description:Unification",F))


                                                
                ##                                print "StackTop NEw", StackTop
##                                                print "Feature unification - print in output"
                                    
                                
                    
                else:
                    uFPresent = False
                                
                if F == "uQ":
                    uFPresent = True #it doesn't matter if a potential goal has any uFs
                    #uFs aren't needed to be visible. 
                    
              
##                elif F[0:4] == "Case":
##                    True
                if F == "uTop":
                    uFPresent = True
                
                if Goal in str(TopFeats):
                    

##                    print "F", F
##                    print "TopFeats", TopFeats
 
                    if StackTop[0] == "_":
                        Unlabeled = True
                    else:
                        Unlabeled = False
                    
                    if uFPresent == True:
                        if Unlabeled == True:
                            True
                        elif "iTop" in Goal:
                                    

                            TopuFs = []
                            
                            for TopF in TopFeats:
                                if TopF[0] == "u":
                                    TopuFs.append(TopF)
                            TopChkd = []
                            if TopuFs != []:
                                for TopuF in TopuFs:
                                    m = re.findall(pattern,TopuF)
                                    OriginalTop = TopuF
                                    if m != []:
                                        TargetTop = m[0]
                                        TargetTopGoal = "i" + TargetTop[1:]
                                    
                                    for TempuFGoal in uFs:
                                        if TargetTopGoal in TempuFGoal:
                                            TopChkdTup = (OriginalTop,TempuFGoal)
                                            TopChkd.append(TopChkdTup)
                                if TopChkd != []:
                                    for tup in TopChkd:
                                        OldTopF = tup[0]
                                        NewTopF = tup[1]
##                                        print "StackTopBefore", StackTop
                                        NewTop = self.ReplaceEverywhere(StackTop,OldTopF,NewTopF)
##                                        print "NewTop", NewTop
##                                        "Add Wa"
##                                        
##                                        print "end", NewTop[-1][-1]
##                                        print "NewTop", NewTop
                                        Form = NewTop[1][0]
##                                        Form = End[0]
                                        NewForm = Form + "-wa"
                                        TopTemp = self.ReplaceEverywhere(NewTop,Form,NewForm)
##                                        print "TopTemp", TopTemp
                                        NewTop = TopTemp
##                                        Head = self.GetHead(NewTop[-1])
                                        
                                        StackTop = NewTop


                                        NewX = self.ReplaceEverywhere(X,OldTopF,NewTopF)
                                        X = NewX
                                        NewY = self.ReplaceEverywhere(Y,OldTopF,NewTopF)
                                        Y = NewY
                                        if OldTopF not in CheckedFeats:
                                            CheckedFeats.append(OldTopF)
                                            CheckedFeatsTup.append(tup)
                                        if self.SubStream == False:
                                            TempStack = self.ReplaceEverywhere(self.Stack,OldTopF,NewTopF)
                                            self.Stack = TempStack
                                        else:
                                            print "Check in substream999999"
                                            sys.exit()
                                                            
                            self.Remerge = StackTop
##                            print "Remerge", StackTop
##                            sys.exit()
                           
                            #Add Copy to any copy in derivation
                            #REmove Copy from remerged version
                            RemergeFeats = self.GetHeadFeatures(self.Remerge)
                            if "Copy" in RemergeFeats:
                                #RemoveCopy
                                NewRemergeFeats = []
                                for RemF in RemergeFeats:
                                    if RemF == "Copy":
                                        True
                                    else:
                                        NewRemergeFeats.append(RemF)
                                NewRemerge = self.ReplaceElemInString(str(self.Remerge),str(RemergeFeats),str(NewRemergeFeats))
                                self.Remerge = eval(NewRemerge)
                                
##                                print "self.Remerge111", self.Remerge
##                                print "\n"
                                                        
                        elif "iQ" in Goal:
                        
                        

    

                            TopuFs = []
                            
                            for TopF in TopFeats:
                                if TopF[0] == "u":
                                    TopuFs.append(TopF)
                            TopChkd = []
                            if TopuFs != []:
                                for TopuF in TopuFs:
                                    m = re.findall(pattern,TopuF)
                                    OriginalTop = TopuF
                                    if m != []:
                                        TargetTop = m[0]
                                        TargetTopGoal = "i" + TargetTop[1:]
                                    
                                    for TempuFGoal in uFs:
                                        if TargetTopGoal in TempuFGoal:
                                            TopChkdTup = (OriginalTop,TempuFGoal)
                                            TopChkd.append(TopChkdTup)
                                if TopChkd != []:
                                    for tup in TopChkd:
                                        OldTopF = tup[0]
                                        NewTopF = tup[1]
##                                        print "StackTopBefore", StackTop
                                        NewTop = self.ReplaceEverywhere(StackTop,OldTopF,NewTopF)
##                                        print "NewTop", NewTop
                                        StackTop = NewTop


                                        NewX = self.ReplaceEverywhere(X,OldTopF,NewTopF)
                                        X = NewX
                                        NewY = self.ReplaceEverywhere(Y,OldTopF,NewTopF)
                                        Y = NewY
                                        if OldTopF not in CheckedFeats:
                                            CheckedFeats.append(OldTopF)
                                            CheckedFeatsTup.append(tup)
                                        if self.SubStream == False:
                                            TempStack = self.ReplaceEverywhere(self.Stack,OldTopF,NewTopF)
                                            self.Stack = TempStack
                                        else:
                                            print "Check in substream999999"
                                            sys.exit()
##
                                            
                            
                                
                            self.Remerge = StackTop
 
                           
                            #Add Copy to any copy in derivation
                            #REmove Copy from remerged version
                            RemergeFeats = self.GetHeadFeatures(self.Remerge)
                            if "Copy" in RemergeFeats:
                                #RemoveCopy
                                NewRemergeFeats = []
                                for RemF in RemergeFeats:
                                    if RemF == "Copy":
                                        True
                                    else:
                                        NewRemergeFeats.append(RemF)
                                NewRemerge = self.ReplaceElemInString(str(self.Remerge),str(RemergeFeats),str(NewRemergeFeats))
                                self.Remerge = eval(NewRemerge)
                                print "self.Remerge111", self.Remerge
                                print "\n"
                                #Find highest instance in derivation and add "Copy"
##                                print "Selected", self.Selected
##                                print "Y", Y
##                                NewMerge = self.ReplaceElemInString(str(Merged),str(NewRemergeFeats),str(RemergeFeats))
                                
                            
                                                        
 
                        #Remerge due to a need to share Q features
                        if Unlabeled == False:
                        
                            for TopF in TopFeats:
                                if Goal in TopF:
                                    CheckedX = self.ReplaceEverywhere(X,F,TopF)
                                    X = CheckedX

                                    CheckedY = self.ReplaceEverywhere(Y,F,TopF)
                                    Y = CheckedY
                                    tup = (F,TopF)
                                    CheckedFeatsTup.append(tup)
                                    if self.SubStream == False:
                                        NewStack = self.ReplaceEverywhere(self.Stack,F,TopF)
                                        self.Stack = NewStack
                                        
                                    else:
                                        NewStack = self.ReplaceEverywhere(self.SubStreamStack,F,TopF)
                                        self.SubStreamStack = NewStack

                                        
##                                        print "Check feats in substream"
##                                        sys.exit()
                            FeatChecked = True
                            CheckedFeats.append(F)
                    #Check uScp as a reflex of uQ checking
                
                    
##                    print "Found it"
##                    print "TopFeats", TopFeats
##                    print "HEadFeats", HeadFeats
 
##                    print "NewXFeats", NewXFeats
##                    sys.exit()
                
 
                                                
                elif "Case:" in F:
##                    print "Case in F", F
##                    print "TopFeats", TopFeats
                    
                    
                   
                    
                    tup = (F,"NONE")
                    CheckedFeatsTup.append(tup)
                    CheckedFeats.append(F)
##                    print "Case", tup
##                    print "YFeats", YFeats
##                    sys.exit()
                    



 
                    NewX = self.ReplaceEverywhere(X,F,"NONE")
                    X = NewX
                    NewStack = self.ReplaceEverywhere(self.Stack,F,"NONE")
                    self.Stack = NewStack
                    NewY = self.ReplaceEverywhere(Y,F,"NONE")
                    Y = NewY
                    
##                    print "YFeats", YFeats
                            

##                    print "CheckCase", F
##                    print "YFeats", YFeats
##                    print "Y", Y
                    NewYFeats = self.GetHeadFeatures(Y)
##                    print "NewYFeats", NewYFeats
##                    print "\n"
##                    print "X", X
##                    print "XFeats", XFeats
                    if self.Language == "Japanese": #head final issue
                        if "uCase" in str(Y):
                            YStr = str(Y)
                            Start = YStr.find("uCase")
                            TempYCont = True
                            End = Start + 1
                            while TempYCont == True:
                                CurrentY = YStr[End]
                                if CurrentY == "'":
                                    TempYCont = False
                                End += 1
                            YFeat = YStr[Start:End-1]
                            CheckedY = self.ReplaceEverywhere(Y,YFeat,F)
                            Y = CheckedY
    ##                            print "YHere", Y
                            tup = (YFeat,F)
                            CheckedFeatsTup.append(tup)
                            if self.SubStream == False:
    ##                                print "OkdStack", self.Stack
                                NewStack = self.ReplaceEverywhere(self.Stack,YFeat,F)
                                self.Stack = NewStack
                        
                                
##    
##                            print "NewY", Y
##                            
##                            sys.exit()
 
                            
                    else:#not Japanese (not head final)
                        for YFeat in YFeats:
                        
                            if "uCase" in YFeat:
    ##                            print "YFeat", YFeat
    ##                            print "Case", F
    ##                            sys.exit() 
                                CheckedY = self.ReplaceEverywhere(Y,YFeat,F)
                                Y = CheckedY
    ##                            print "YHere", Y
                                tup = (YFeat,F)
                                CheckedFeatsTup.append(tup)
                                if self.SubStream == False:
    ##                                print "OkdStack", self.Stack
                                    NewStack = self.ReplaceEverywhere(self.Stack,YFeat,F)
                                    self.Stack = NewStack
                                    
    ##                                print "NewStack", self.Stack
    ##                                sys.exit()
                                    
                                    
                                else:
                                    NewStack = self.ReplaceEverywhere(self.SubStreamStack,YFeat,F)
                                    self.SubStreamStack = NewStack
                                   
                    
####                    print "X", X
####                    print "Y", Y
##                    sys.exit()
                    FeatChecked = True
 
##                            print "X", X
##                            print "Y", Y
##    ##                        
##                            sys.exit()
                            
                    
                elif F == "uPhi":
                
 
                    if "iPerson" in str(TopFeats):
##                        print "F", F
##                        print "TopFeats", TopFeats
##                        sys.exit()
                        
                        NewXFeats = []
                        for TempXFeat in XFeats:
                            if TempXFeat == "uPhi":
                                True
                            else:
                                NewXFeats.append(TempXFeat)
##                        for TopF in TopFeats:
##                            if TopF not in NewXFeats:
##                                NewXFeats.append(TopF)
##                        
                        for TopF in TopFeats:
                            if "iPerson" in TopF:
                                
                                NewXFeats.append(TopF)
                            elif "iNumber" in TopF:
                                NewXFeats.append(TopF)
                            elif "iGender" in TopF:
                                NewXFeats.append(TopF)
                            elif "uCase" in TopF:
                                NewXFeats.append(TopF)
                                
##                    print "uPhi replace", F
##                    print "X"
##                    print "XFeats", XFeats
##                    print "NewXFeats", NewXFeats
                    NewX = self.ReplaceFeats(X,XFeats,NewXFeats)
##                    print "NewX", NewX
##                    sys.exit()
                    X = NewX
                    XFeats = NewXFeats
##                    print "NewX", X
##                    sys.exit()
                    self.Output_L.append(("Description:PhiPassing","uPhi"))
                    FeatChecked = True
                    self.InheritanceCtr += 1
                                
                                


                    




                    
                if FeatChecked == True:
                    FeatCtr += 1
                    if self.SubStream == False:
                
                        StackCtr = len(self.Stack) - 1 #top element should be identical to probe
                    else:
                        StackCtr = len(self.SubStreamStack) - 1
                else:
                    StackCtr -= 1
                    if StackCtr < 0:
                        FeatCtr += 1
                        if self.SubStream == False:
                
                            StackCtr = len(self.Stack) - 1 #top element should be identical to probe
                        else:
                            StackCtr = len(self.SubStreamStack) - 1
        

                
                            
        if CheckedFeats != []:
            CheckedFs = " ".join(CheckedFeats)
            self.Output_L.append(("Description:CheckedFeatures",CheckedFs))
            self.FTCheckCtr += len(CheckedFeats)


                      
                     
##        print "XOutput", X
##        print "YOutput", Y
####        if "Person12" in str(XFeats):
####            print "Stop here"
####            sys.exit()
####        print "Remerge", self.Remerge
##        print"\n\n"
        return (X,Y,CheckedFeatsTup)
                        
                    
 

                                    
##                                    print "StackAgain", Stack
##                                    sys.exit()
##                        if Checked == False:
##                            NewHeadFeats.append(F)
##                    
##                    
##                    if PhiChecked == True:
##                        if "uCase" in TopFeats:
##                            #find Case
##                            for HeadF in NewHeadFeats:
##                                if "Case:" in HeadF:
##                                    CaseF = HeadF
##                            NewTopFeats = []
##                            for TopF in TopFeats:
##                                if "uCase" in TopF:
##                                    NewTopFeats.append(CaseF)
##                                else:
##                                    NewTopFeats.append(TopF)
##                            StackReplace = True
##                            while StackReplace == True:
##                                if str(TopFeats) in str(self.Stack):
##                                    NewStack = self.ReplaceElemInString(str(self.Stack),str(TopFeats),str(NewTopFeats))
##                                    self.Stack = eval(NewStack)
##                                else:
##                                    StackReplace = False
##                                
##                            NewSO = self.ReplaceElemInString(str(SO),str(TopFeats),str(NewTopFeats))
####                            print "NewSO", NewSO
####                            print "TopFeats", TopFeats
####                            print "Stack", Stack
####                            for Elem in Stack:
####                                print "Stack: Elem", Elem
####                            sys.exit()
####                            print "\n\n\n"
##                            SO = eval(NewSO)
##
##                            
####                            Stack = eval(TempStack)
####                            TempSO = re.sub(str(TopFeats),str(NewTopFeats),str(SO))
####                            SO = eval(TempSO)
####                            print "NewTopFeat", NewTopFeats
##                                    
##                            
##
##                    
##
####                    print "NewSO", NewSO
####                    for elem in Stack:
####                        print "Stack Elem", elem
####                    sys.exit()
##                    if CheckedFeats != []:
##                        CheckedFs = " ".join(CheckedFeats)
##                        self.Output_L.append(("Description:CheckedFeatures",CheckedFs))
##
####                    print "CheckedFs", CheckedFs
##                    ##put everything back
####                    print "put everything back"
##                                        
####                    Cont = False
##                    
####                    sys.exit()
##                    
## 
##                    
##                else:
####                    print "GoalNotPResent: Copy"
##                    NewTopFeats = TopFeats + uFs #Copy features
####                    print "StackTop", StackTop
####                    print "NewTopFeats", NewTopFeats
## 
##                   
##
##
##                                    
##                    NewStackTop = self.ReplaceElemInString(str(StackTop),str(TopFeats),str(NewTopFeats))
####                    print "NewStackTop", NewStackTop
##
##
##
##                    StackReplace = True
##                    while StackReplace == True:
##                        if str(StackTop) in str(self.Stack):
##                            NewStack = self.ReplaceElemInString(str(self.Stack),str(StackTop),str(NewStackTop))
##                            self.Stack = eval(NewStack)
##                        else:
##                            StackReplace = False
##
##                                    
####                    NewStack = self.ReplaceElemInString(str(self.Stack),str(StackTop),str(NewStackTop))
####                    self.Stack = eval(NewStack)
####                    print "StackTop", StackTop
####                    print "NewSTackTop", NewStackTop
####                    print "SO", SO
##                    if NewStackTop not in str(SO):
##                        NewSO = self.ReplaceElemInString(str(SO),str(StackTop),str(NewStackTop))
##                    
##                    
##                        SO = NewSO
####                    print "NewSO", NewSO
####                    for Elem in self.Stack:
####                        print "Stack1", Elem
####                    FeatCtr = len(uFs)
##                    StackCtr -= 1
##                    
##                    
##                    
####                    sys.exit()
##                
####                    FeatCtr += 1
####                    if FeatCtr == len(uFs) - 1:
####                        Cont = False
####                        print "Continue is False"
####                        print "\n\n"
##            if len(RemovedFeats) > 0:
##                NewFeats = []
##                for F in HeadFeats:
##                    if F in RemovedFeats:
##                        NewF = RemovedFeats[F]
##                        NewFeats.append(NewF)
##                    else:
##                        NewFeats.append(F)
##                print "HeadFeats", HeadFeats
##                print "NewFEats", NewFeats
##                sys.exit()
##


          
        


            

        
        
        
        

        
                    
    def ReplaceEverywhere(self,Element,OldChunk,NewChunk):
##        print "\nElement", Element
##        print "OldChunk", OldChunk
##        print "NewChunk", NewChunk
##        print len(NewChunk)
        ElemStr = str(Element)
##        if OldChunk[-1] == "]":
##            LastBracket = True
##        else:
##            LastBracket = False
##        if LastBracket == True:
##            EndIndicators = set([","])
##        else:
        EndIndicators = set(["'","]",","])
        ctr = 0
        NewElemString = str()
        End = len(ElemStr) - len(OldChunk)
        MainLoop = True
        while MainLoop == True:
            #Find all relevant chunks and replace
            
            Chunk = ElemStr[ctr:ctr+len(OldChunk)]
            Found = False
##            if Chunk == OldChunk:
            
            if OldChunk == Chunk:
                NewElemString += NewChunk
                ctr += len(OldChunk)
                Found = True
 
                                   
## 
            if Found == False:
                NewElemString += ElemStr[ctr]
                ctr += 1
            if ctr + len(OldChunk) >= len(ElemStr):
                NewElemString += ElemStr[ctr:]
                MainLoop = False
            
##        NewElemString += ElemStr[-len(OldChunk):]
##        print "NEwElem", NewElemString
##        sys.exit()
##        print "NEwElem", NewElem
##        print "\n"
        if NewChunk == "NONE":
            #Remove NONE
            Temp = re.sub(", 'NONE'","",NewElemString)
            NewElemString = Temp
##        print "Old Element", Element
##        print "NewElemString", NewElemString

        NewElem = eval(NewElemString)
##        print "NewElem", NewElem
        return NewElem

    
    def ReplaceEverywhereOld(self,Element,OldChunk,NewChunk):
        print "\nElement", Element
        print "OldChunk", OldChunk
        print "NewChunk", NewChunk
##        print len(NewChunk)
        ElemStr = str(Element)
##        if OldChunk[-1] == "]":
##            LastBracket = True
##        else:
##            LastBracket = False
##        if LastBracket == True:
##            EndIndicators = set([","])
##        else:
        EndIndicators = set(["'","]"])
        ctr = 0
        NewElemString = str()
        End = len(ElemStr) - len(OldChunk)
        MainLoop = True
        while MainLoop == True:
            #Find all relevant chunks and replace
            
            Chunk = ElemStr[ctr:ctr+len(OldChunk)]
            Found = False
##            if Chunk == OldChunk:
            
            if OldChunk == Chunk:
 
                                   
##                print "Found it"
##                print ElemStr[:ctr+len(OldChunk)]
                Next = ctr + len(OldChunk)
                
##                print "NExt", ElemStr[Next]
                Cont = True
                ctr += len(OldChunk)
                while Cont == True:
                    
                    if ElemStr[Next] in EndIndicators:
                        #Find the last end indicator
                        Found = True
                        NewElemString += NewChunk
##                        print "NewelemString", NewElemString
                        
                        
##                        if ctr + len("Unify") < len(ElemStr):
##                            StartTemp = ctr + 1
##                            if ElemStr[StartTemp:StartTemp+len("Unify")] == "Unify":
##                                print "Found it"
##                                print ElemStr[StartTemp:]
##                                sys.exit()
                        Cont = False
                    
                    else:
                        Next += 1
##                        if Next == len(ElemStr):
##                            Found = True
##                            NewElemString += NewChunk
##                            Cont = False
                        ctr += 1
##                    ctr += len(OldChunk)
            if Found == False:
                NewElemString += ElemStr[ctr]
                ctr += 1
            if ctr + len(OldChunk) >= len(ElemStr):
                NewElemString += ElemStr[ctr:]
                MainLoop = False
            
##        NewElemString += ElemStr[-len(OldChunk):]
##        print "NEwElem", NewElemString
##        sys.exit()
##        print "NEwElem", NewElem
##        print "\n"
        if NewChunk == "NONE":
            #Remove NONE
            Temp = re.sub(", 'NONE'","",NewElemString)
            NewElemString = Temp
        print "Old Element", Element
        print "NewElemString", NewElemString

        NewElem = eval(NewElemString)

        return NewElem       
                            

                            
        
    def CheckFeatsOld(self,SO):

        
##        print "SO - check Feats", SO
        HeadFeats = self.GetHeadFeatures(SO)
        Head = SO[0]
        

        #Remove MergeF - just to distinguish simple and complex objects
                
        if "MergeF" in HeadFeats:
            NewHeadFeats = []
            for F in HeadFeats:
                if F == "MergeF":
                    True
                else:
                    NewHeadFeats.append(F)
            
            NewSO = self.ReplaceElemInString(str(SO),str(HeadFeats),str(NewHeadFeats))
            SO = eval(NewSO)
##            print "NEwSO", NewSO
##            NewStack = self.ReplaceElemInString(str(Stack),str(HeadFeats),str(NewHeadFeats))
##            Stack = eval(NewStack)

                    
            self.ReplaceElemInStack(str(HeadFeats),str(NewHeadFeats))
            HeadFeats = NewHeadFeats


            
        #special rule to pass phi-features from N to D
        if Head != "n":
            if "uCase" in HeadFeats:
                if "uPhi" in HeadFeats:
                    
    ##                ctr = len(self.Stack) - 1
##                    print "Head", Head
##                    print "Stack", self.Stack
##                    
                    StackTop = self.Stack[-1]
                    TopFeats = self.GetHeadFeatures(StackTop)
                    
                    if "iPerson" in str(TopFeats):
                        NewFeats = []
                        for F in TopFeats:
                            NewFeats.append(F)

                        NewHeadFeats = []
                        for F in HeadFeats:
                            if F == "uPhi":
                                True
                            else:
                                NewHeadFeats.append(F)
                        NewHeadFeats += NewFeats
                        #pass uCase from n to D
                        NewTopFeats = []
                        for F in TopFeats:
                            if F == "uCase":
                                True
                            else:
                                NewTopFeats.append(F)
                        NewStack = self.ReplaceElemInString(str(self.Stack),str(TopFeats),str(NewTopFeats))
                        self.Stack = eval(NewStack)
                                            
                        self.Output_L.append(("Description:PhiPassing","uPhi"))
                        NewSO = self.ReplaceElemInString(str(SO),str(HeadFeats),str(NewHeadFeats))
                        NewSO1 = self.ReplaceElemInString(str(NewSO),str(TopFeats),str(NewTopFeats))
                        SO = eval(NewSO1)
                        self.InheritanceCtr += 1




##            self.ReplaceElemInStack(str(HeadFeats),str(NewHeadFeats))
        
        if self.Phase == True:
##            print "Phase is True"
##            print "SO", SO
##            print "STack"
##            for p in self.Stack:
##                print "Stack:", p
##            print "\n\n"
            #All uFs on Phase head must be checked
            #uFs on phase head must be checked by potential goal or transfered to potential goal
            HeadFeats = self.GetHeadFeatures(SO)
##            print "HeadFeats", HeadFeats
            uFs = []
##            print "phase"
            for F in HeadFeats:
                if F[0] == "u": 
                    uFs.append(F)
            if uFs == []:
                print "no uFs in Phase head"
                print "Exit 1234"
                sys.exit()
            FeatCtr = 0
            StackCtr = len(self.Stack) - 1 #top element should be identical to probe
            RemovedFeats = dict()
            Cont = True
            CheckedFeats = []
            while Cont == True:
##            while FeatCtr < len(uFs):
                F = uFs[FeatCtr]
                Goal = "i" + F[1:]
##                print "Goal", Goal
                StackTop = self.Stack[StackCtr]
##                print "StackTop", StackTop
                TopFeats = self.GetHeadFeatures(StackTop)
##                print "TopFeats", TopFeats
##                print "\n"
                if TopFeats == None:
                    sys.exit()

                PhiChecked = False
                
                if Goal in str(TopFeats):
                    FeatCtr += 1
                    
##                    print "Found it"
##                    print "TopFeats", TopFeats
##                    print "HEadFeats", HeadFeats
                    Cont = False
                    NewHeadFeats  = []
                    for F in HeadFeats:
                        Checked = False
                        if F[0] == "u":
                            Goal = "i" + F[1:]
                            for TopFeat in TopFeats:
                                if Goal in TopFeat:
                                    NewHeadFeats.append(Goal)
                                    Checked = True
                                    if Goal in PhiFeats:
                                        PhiChecked = True
                                    CheckedFeats.append(F)
                                    #check all instances of this feature everywhere
##                                    print "Stack", Stack
##                                    print "NEwFeat", TopFeat
##                                    print "Old", F
##                                    print "Stack", self.Stack
##                                    sys.exit()
                                    StackReplace = True
                                    while StackReplace == True:
                                        if F in str(self.Stack):
                                            NewStack = self.ReplaceElemInString(str(self.Stack),F,TopFeat)
                                            self.Stack = eval(NewStack)
                                        else:
                                            StackReplace = False
                                  



                                    
##                                    TempStack = re.sub(F,TopFeat,str(Stack))
##                                    Stack = eval(TempStack)
                                    TempSO = re.sub(F,TopFeat,str(SO))
                                    SO = eval(TempSO)

                                    
##                                    print "StackAgain", Stack
##                                    sys.exit()
                        if Checked == False:
                            NewHeadFeats.append(F)
                    
                    
                    if PhiChecked == True:
                        if "uCase" in TopFeats:
                            #find Case
                            for HeadF in NewHeadFeats:
                                if "Case:" in HeadF:
                                    CaseF = HeadF
                            NewTopFeats = []
                            for TopF in TopFeats:
                                if "uCase" in TopF:
                                    NewTopFeats.append(CaseF)
                                else:
                                    NewTopFeats.append(TopF)
                            StackReplace = True
                            while StackReplace == True:
                                if str(TopFeats) in str(self.Stack):
                                    NewStack = self.ReplaceElemInString(str(self.Stack),str(TopFeats),str(NewTopFeats))
                                    self.Stack = eval(NewStack)
                                else:
                                    StackReplace = False
                                
                            NewSO = self.ReplaceElemInString(str(SO),str(TopFeats),str(NewTopFeats))
##                            print "NewSO", NewSO
##                            print "TopFeats", TopFeats
##                            print "Stack", Stack
##                            for Elem in Stack:
##                                print "Stack: Elem", Elem
##                            sys.exit()
##                            print "\n\n\n"
                            SO = eval(NewSO)

                            
##                            Stack = eval(TempStack)
##                            TempSO = re.sub(str(TopFeats),str(NewTopFeats),str(SO))
##                            SO = eval(TempSO)
##                            print "NewTopFeat", NewTopFeats
                                    
                            

                    

##                    print "NewSO", NewSO
##                    for elem in Stack:
##                        print "Stack Elem", elem
##                    sys.exit()
                    if CheckedFeats != []:
                        CheckedFs = " ".join(CheckedFeats)
                        self.Output_L.append(("Description:CheckedFeatures",CheckedFs))
                        self.FTCheckCtr += len(CheckedFeats)

##                    print "CheckedFs", CheckedFs
                    ##put everything back
##                    print "put everything back"
                                        
##                    Cont = False
                    
##                    sys.exit()
                    
 
                    
                else:
##                    print "GoalNotPResent: Copy"
                    NewTopFeats = TopFeats + uFs #Copy features
##                    print "StackTop", StackTop
##                    print "NewTopFeats", NewTopFeats
 
                   


                                    
                    NewStackTop = self.ReplaceElemInString(str(StackTop),str(TopFeats),str(NewTopFeats))
##                    print "NewStackTop", NewStackTop



                    StackReplace = True
                    while StackReplace == True:
                        if str(StackTop) in str(self.Stack):
                            NewStack = self.ReplaceElemInString(str(self.Stack),str(StackTop),str(NewStackTop))
                            self.Stack = eval(NewStack)
                        else:
                            StackReplace = False

                                    
##                    NewStack = self.ReplaceElemInString(str(self.Stack),str(StackTop),str(NewStackTop))
##                    self.Stack = eval(NewStack)
##                    print "StackTop", StackTop
##                    print "NewSTackTop", NewStackTop
##                    print "SO", SO
                    if NewStackTop not in str(SO):
                        NewSO = self.ReplaceElemInString(str(SO),str(StackTop),str(NewStackTop))
                    
                    
                        SO = NewSO
##                    print "NewSO", NewSO
##                    for Elem in self.Stack:
##                        print "Stack1", Elem
##                    FeatCtr = len(uFs)
                    StackCtr -= 1
                    
                    
                    
##                    sys.exit()
                
##                    FeatCtr += 1
##                    if FeatCtr == len(uFs) - 1:
##                        Cont = False
##                        print "Continue is False"
##                        print "\n\n"
            if len(RemovedFeats) > 0:
                NewFeats = []
                for F in HeadFeats:
                    if F in RemovedFeats:
                        NewF = RemovedFeats[F]
                        NewFeats.append(NewF)
                    else:
                        NewFeats.append(F)
                print "HeadFeats", HeadFeats
                print "NewFEats", NewFeats
                sys.exit()
                
                    
                
 
##        print "REturn Feature Checking:", SO
##        for Elem in self.Stack:
##            print "FeatCheck ", Elem
##        print "\n\n\n"
        return SO

                        
                
##                                NewHeadFeats = []
##                                NewHeadFeats.append("uCase")
##                                
##                                for F in TopFeats:
##                                    NewHeadFeats.append(F)
##                                print "NewHEadFeats", NewHeadFeats
##                                self.Output_L.append(("Description:PhiFeaturePassing",str(NewHeadFeats)))
##                                NewSO = self.ReplaceElemInString(str(SO),str(HeadFeats),str(NewHeadFeats))
##                                SO = eval(NewSO)
####                                print "SO", SO
##                                self.ReplaceElemInStack(str(HeadFeats),str(NewHeadFeats))
##                                return SO
##                    else:
##                        print "F", F
                                
                    
##                    ctr -= 1
                    
                        
##                sys.exit()
        ###this works for English, but may not work for a head final language
##        HeadFeatsStr = str(HeadFeats)
##        SOString = str(SO)
##        Start = SOString.index(HeadFeasStr)
        
        return False
        #search through aeady formed syntactic object
        #might be easier with a stack????

    def ReplaceElemInStack(self,OldFeats,NewFeats):
        Temp = []
        for elem in self.Stack:
            if OldFeats in str(elem):
                NewElem = self.ReplaceElemInString(str(elem),OldFeats,NewFeats)
                NewElem1 = eval(NewElem)
                Temp.append(NewElem1)
            else:
                Temp.append(elem)
        self.Stack = Temp

        
    def ReplaceElemInString(self,String,OldChunk,NewChunk):

        StartChunk = String.index(OldChunk)
        NewString = String[:StartChunk]+NewChunk+String[StartChunk+len(OldChunk):]
        return NewString           
   
    def CopyForm(self,line):
        print "Copy Input", line
        #if a chunk is a word, then mark it as a copy
        new_line = str()
        ctr = 0
        while ctr < len(line):
            current = line[ctr]
            if current == "'":
                new_line += current
                chunk = str()
                Cont = True
                ctr += 1
                while Cont == True:
                    current = line[ctr]
                    if current == "'":
                        Cont = False
                    else:
                        chunk += current
                        ctr += 1
                Output = self.CheckIfFeat(chunk)
                chunk += current

                if Output == True:

##                    print "feat", chunk
                    new_line += chunk
                else:
                    NewChunk = "_" + chunk
                    new_line += NewChunk
                ctr += 1
##                current = line[ctr]
##                new_line += current
            else:
                new_line += current
                ctr += 1
##        print "new_line", new_line
##        sys.exit()
        return new_line
    
    def CheckIfFeat(self,chunk):
        
        pattern = r'u[A-Z]'
        m = re.findall(pattern,chunk)
        if chunk in OtherFts:
            
            return True
        if len(chunk) > 4:
            if chunk[:4] == "Chkd":
                return True
        if m != []:
            return True
        pattern = r'i[A-Z]'
        m = re.findall(pattern,chunk)
        if m != []:
            return True
        else:
            return False

def Start(InputData):
    f = open(InputData, 'r')
    InputData = f.readlines()
    f.close()
    a = Generate(InputData)


                    


InputData = "../Languages/English/Sentences/POP.txt"
##InputData = "../Languages/Japanese/DisWarn.txt"

Start(InputData)
